--| Purpose: SpartanUI logic
--| Author: Jonathan Woodburn (a.k.a. Ansu)
--| URL: www.SpartanUI.com


--|  Toggles & Var initiation  |--

SUI_currentVersion = 2.051
isSpinning = 0									-- SpinCam on/off switch (starts off)
SuiToggle = 0 									-- toggle for functions
FrameAdvance = 0 								-- Universal start frame
SUI_VarUpdateInterval = 1 						-- How often the OnUpdate code will run (in seconds)
TimeSinceLastUpdate_GeneralInterval = 0
TimeSinceLastUpdate_AnimationInterval = 0
TimeSinceLastUpdate_FastInterval = 0
SUI_ReadyCheckTimer = 60
godmode=0
SUI_NanVar=0/0
FileFormat=".blp"
sessionMarker=GetTime()
sessionXP=UnitXP("player")
suiData = {}

function Sui_OnLoad()
	SlashCmdList["SUI"] = Sui_SlashCommand
	SLASH_SUI1 = "/sui"
	SLASH_SUI2 = "/spartanui"
	Sui_RegisterEvents()
	Sui_Setup()
end


--|  Command List  |--

function Sui_SlashCommand(msg)
	local msg, arg1, arg2 = strsplit(" ", msg)
	local msg = string.lower(msg)
	if msg==SUIL.ENGLISH.UI.TEST or msg==SUI_Lang.UI.TEST then
		if not arg1 then 
			DEFAULT_CHAT_FRAME:AddMessage("Need an argument", 0.5, 0.5, 0.5)
		else
			local runN = 0
			local runC = 0
			local runS = 0
			SUI_MouseTooltip_Text:SetText("Results for "..arg1..":\r\r")
			for i,v in pairs(_G) do
				if type(v) == "string" then
					runN = runN + 1
  					local start, finish = string.find(v, arg1, 1, true)
  					if start then
  						runC = runC + 1
  						local tablename = tostring(_G)
  						local text = SUI_MouseTooltip_Text:GetText()
						local text = text.."|cffffc100"..tablename..":|r ".."|c00FF0000"..i..":|r "..v.."\r"
						SUI_MouseTooltip_Text:SetText(text)
  					end
	  			elseif type(v) == "table" then
					for l,q in ipairs(_G[i]) do
						if type(q) == "string" then
							runS = runS + 1
  							local start, finish = string.find(q, arg1, 1, true)
  							if start then
  								runC = runC + 1
  								local tablename = tostring(v)
  								local text = SUI_MouseTooltip_Text:GetText()
								local text = text.."|cffffc100"..tablename..":|r ".."|c00FF0000"..l..":|r "..q.."\r"
								SUI_MouseTooltip_Text:SetText(text)
							end
						end
  					end
  				end
				--local text = SUI_MouseTooltip_Text:GetText()
				--local text = text.."\r\rIterated "..runN.." times | Subran "..runS.." times | Found "..runC.." matches"
				--SUI_MouseTooltip_Text:SetText(text)
				SUI_MouseTooltip:Show()
			end
		end
	elseif msg==SUIL.ENGLISH.UI.GODMODE or msg==SUI_Lang.UI.GODMODE then
		DEFAULT_CHAT_FRAME:AddMessage("Entering God Mode.", 1.0, 0, 0.0)
		DEFAULT_CHAT_FRAME:AddMessage("Now go beat up some Horde, "..UnitName("player")..".  :)", .5, .5, .5)
		godmode=1
	elseif msg==SUIL.ENGLISH.UI.MAXRES or msg==SUI_Lang.UI.MAXRES then
		if suiData.scale == .92 then
			suiData.scale = .78
		else
			suiData.scale = .92
		end
		SpartanUI:SetScale(suiData.scale)
	elseif msg==SUIL.ENGLISH.UI.VERSION or msg==SUI_Lang.UI.VERSION or msg=="vers" then
		local channel
		if arg1 then
			channel = "WHISPER"
		elseif UnitInRaid("player")then
			channel = "RAID"
		elseif GetNumPartyMembers() > 0 then
			channel = "PARTY"
		elseif GetGuildInfo("player") then
			channel = "GUILD"
		else
			channel = nil
		end
		
		if channel then
			local channelname = string.lower(channel)
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI: version check broadcast to ".. channelname..".", 1, 0.75, 0)
			SendAddonMessage("SUI", "find "..UnitName("player").." version ".."current", channel, arg1 or UnitName("target"))
		else
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI: version info only available for specific units, raid, or in-guild.", 0.65, 0.65, 0.65)
		end
	elseif msg=="lang" then
		if arg1=="english" or arg1==SUIL.ENGLISH.LANGUAGE then
			SUI_Lang = SUIL.ENGLISH
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI v2 "..SUI_Lang.UI.LANGUAGE.." loaded.", 0.65, 0.65, 0.65)
		elseif arg1=="french" or arg1==SUIL.FRENCH.LANGUAGE then
			SUI_Lang = SUIL.FRENCH
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI v2 "..SUI_Lang.UI.LANGUAGE.." loaded.", 0.65, 0.65, 0.65)
		elseif arg1=="greek" or arg1==SUIL.GREEK.LANGUAGE then
			SUI_Lang = SUIL.GREEK
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI v2 "..SUI_Lang.UI.LANGUAGE.." loaded.", 0.65, 0.65, 0.65)
		elseif arg1=="italian" or arg1==SUIL.ITALIAN.LANGUAGE then
			SUI_Lang = SUIL.ITALIAN
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI v2 "..SUI_Lang.UI.LANGUAGE.." loaded.", 0.65, 0.65, 0.65)
		elseif arg1=="swedish" or arg1==SUIL.SWEDISH.LANGUAGE then
			SUI_Lang = SUIL.SWEDISH
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI v2 "..SUI_Lang.UI.LANGUAGE.." loaded.", 0.65, 0.65, 0.65)
		elseif arg1=="danish" or arg1==SUIL.DANISH.LANGUAGE then
			SUI_Lang = SUIL.DANISH
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI v2 "..SUI_Lang.UI.LANGUAGE.." loaded.", 0.65, 0.65, 0.65)
		elseif arg1=="russian" or arg1==SUIL.RUSSIAN.LANGUAGE then
			SUI_Lang = SUIL.RUSSIAN
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI v2 "..SUI_Lang.UI.LANGUAGE.." loaded.", 0.65, 0.65, 0.65)
		elseif arg1=="spanish" or arg1==SUIL.SPANISH.LANGUAGE then
			SUI_Lang = SUIL.SPANISH
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI v2 "..SUI_Lang.UI.LANGUAGE.." loaded.", 0.65, 0.65, 0.65)
		elseif arg1=="korean" or arg1==SUIL.KOREAN.LANGUAGE then
			SUI_Lang = SUIL.KOREAN
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI v2 "..SUI_Lang.UI.LANGUAGE.." loaded.", 0.65, 0.65, 0.65)
		elseif arg1=="norwegian" or arg1==SUIL.NORWEGIAN.LANGUAGE then
			SUI_Lang = SUIL.NORWEGIAN
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI v2 "..SUI_Lang.UI.LANGUAGE.." loaded.", 0.65, 0.65, 0.65)
		elseif arg1=="german" or arg1==SUIL.GERMAN.LANGUAGE then
			SUI_Lang = SUIL.GERMAN
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI v2 "..SUI_Lang.UI.LANGUAGE.." loaded.", 0.65, 0.65, 0.65)
		elseif arg1=="chinese" or arg1==SUIL.CHINESE.LANGUAGE then
			SUI_Lang = SUIL.TRADITIONAL_CHINESE
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI v2 "..SUI_Lang.UI.LANGUAGE.." loaded.", 0.65, 0.65, 0.65)
		else
			DEFAULT_CHAT_FRAME:AddMessage(arg1.." language is not available.", 0.65, 0.65, 0.65)
		end
	elseif msg=="stat" then
		local channel
		if arg1 then
			channel = "WHISPER"
		elseif UnitInRaid("player")then
			channel = "RAID"
		elseif GetNumPartyMembers() > 0 then
			channel = "PARTY"
		elseif GetGuildInfo("player") then
			channel = "GUILD"
		else
			channel = nil
		end
		if channel then
			local channelname = string.lower(channel)
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI: stat check broadcast to ".. channelname..".", 1, 0.75, 0)
			SendAddonMessage("SUI", "find "..UnitName("player").." performance ".."content", channel, arg1)
		else
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI: stat info only available for specific units, raid, or in-guild.", 0.65, 0.65, 0.65)
		end
	elseif msg=="chatter" then
		Sui_Chatter(arg1)
	elseif msg=="buff" then
		if arg1=="off" then
			this:UnregisterEvent("PLAYER_AURAS_CHANGED")
			this:UnregisterEvent("UNIT_AURA")
			suiData.buffToggle = "off"
		elseif arg1=="on" then
			this:RegisterEvent("PLAYER_AURAS_CHANGED")
			this:RegisterEvent("UNIT_AURA")
			suiData.buffToggle = "on"
		end
	elseif msg=="event" then
		Sui_FindEvents(arg1)
	elseif msg=="children" then
		Sui_FindChildren(arg1)
	elseif msg=="party" then
		if arg1=="off" then
			suiData.partyToggle = arg1
			if UnitExists("party1") then
				SUI_Party1:Hide()
			end
			if UnitExists("party2") then
				SUI_Party2:Hide()
			end
			if UnitExists("party3") then
				SUI_Party3:Hide()
			end
			if UnitExists("party4") then
				SUI_Party4:Hide()
			end
		elseif arg1=="on" then
			suiData.partyToggle = arg1
			if UnitExists("party1") then
				SUI_Party1:Show()
			end
			if UnitExists("party2") then
				SUI_Party2:Show()
			end
			if UnitExists("party3") then
				SUI_Party3:Show()
			end
			if UnitExists("party4") then
				SUI_Party4:Show()
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("SpartanUI: To toggle party members type /sui party on or /sui party off", 0.5, 0.5, 0.5)
		end
	elseif msg=="help" then
		Sui_HelpMenu()
	elseif msg=="dev" then
		Sui_HelpMenu("dev")
	elseif msg=="chatfont" then
		ChatFrame1:SetFontObject(SUI_FontCognosis)
	elseif msg=="effect" then
		FEDB.root = "Interface\\AddOns\\SpartanUI\\Support\\"
		FG_OnEvent(arg1, arg2)
	end
end

function Sui_HelpMenu(arg1)
	if not arg1 then
		DEFAULT_CHAT_FRAME:AddMessage("SpartanUI Help Menu:", 1, 0.75, 0)
		DEFAULT_CHAT_FRAME:AddMessage("Type /sui or /spartanui and then any of the following", 0.75, 0.75, 0.75)
		DEFAULT_CHAT_FRAME:AddMessage("|c00ffffffversion|r (checks versions of SUI in group)", 0.75, 0.75, 0.75)
		DEFAULT_CHAT_FRAME:AddMessage("|c00ffffffmaxres|r (toggles 1:1 ratio for large displays)", 0.75, 0.75, 0.75)
		DEFAULT_CHAT_FRAME:AddMessage("|c00ffffffchatter on/off|r (removes NPC chatter from chat)", 0.75, 0.75, 0.75)
		DEFAULT_CHAT_FRAME:AddMessage("|c00ffffffeffect vignette, film blur, or film crisp|r (film effects for flare)", 0.75, 0.75, 0.75)
		DEFAULT_CHAT_FRAME:AddMessage("|c00ffffffdev|r (developer tools used in SUI)", 0.75, 0.75, 0.75)
		DEFAULT_CHAT_FRAME:AddMessage("|c00fffffflang X|r (switch language to x)", 0.75, 0.75, 0.75)
		DEFAULT_CHAT_FRAME:AddMessage("|c00ffffffAvailable languages:|r " .. (SUIL.AVAILABLE_LANGUAGES[1]), 0.75, 0.75, 0.75)
	elseif arg1=="dev" then
		DEFAULT_CHAT_FRAME:AddMessage("SpartanUI Developer tools:", 1, 0.75, 0)
		DEFAULT_CHAT_FRAME:AddMessage("|c00fffffftest X|r (find X string in global table)", 0.75, 0.75, 0.75)
		DEFAULT_CHAT_FRAME:AddMessage("|c00ffffffevent X|r (find events registered to X frame)", 0.75, 0.75, 0.75)
		DEFAULT_CHAT_FRAME:AddMessage("|c00ffffffchildren X|r (find child frames of frame X)", 0.75, 0.75, 0.75)
	end
end

--|  Event Registration  |--

function Sui_RegisterEvents()
	this:RegisterEvent("ADDON_LOADED")
	this:RegisterEvent("CHAT_MSG_SYSTEM")
	this:RegisterEvent("CHAT_MSG_CHANNEL")
	this:RegisterEvent("CHAT_MSG_ADDON")
	this:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")
	this:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN")
	this:RegisterEvent("VOICE_START")
	this:RegisterEvent("VOICE_STOP")
	this:RegisterEvent("UNIT_HEALTH")
	this:RegisterEvent("UNIT_MANA")
	this:RegisterEvent("UNIT_RAGE")
	this:RegisterEvent("UNIT_ENERGY")
	this:RegisterEvent("UNIT_FOCUS")
	this:RegisterEvent("UNIT_LEVEL")
	this:RegisterEvent("UNIT_COMBAT")
	this:RegisterEvent("UNIT_FACTION")
	this:RegisterEvent("UNIT_PET")
	this:RegisterEvent("UNIT_PORTRAIT_UPDATE")
	this:RegisterEvent("UPDATE_FACTION")
	this:RegisterEvent("UPDATE_INVENTORY_ALERTS")
	this:RegisterEvent("PARTY_MEMBERS_CHANGED")
	this:RegisterEvent("PARTY_LEADER_CHANGED")
	this:RegisterEvent("PARTY_LOOT_METHOD_CHANGED")
	this:RegisterEvent("PLAYER_ENTERING_WORLD")
	this:RegisterEvent("PLAYER_ENTER_COMBAT")
	this:RegisterEvent("PLAYER_FOCUS_CHANGED")
	this:RegisterEvent("PLAYER_LEAVE_COMBAT")
	this:RegisterEvent("PLAYER_REGEN_DISABLED")
	this:RegisterEvent("PLAYER_REGEN_ENABLED")
	this:RegisterEvent("PLAYER_UPDATE_RESTING")
	this:RegisterEvent("PLAYER_XP_UPDATE")
	this:RegisterEvent("PLAYER_DEAD")
	this:RegisterEvent("PLAYER_TARGET_CHANGED")
	this:RegisterEvent("PLAYER_COMBO_POINTS")
	this:RegisterEvent("PLAYER_FLAGS_CHANGED")
	this:RegisterEvent("QUEST_LOG_UPDATE")
	this:RegisterEvent("PLAYER_LEAVING_WORLD")
	this:RegisterEvent("PLAYER_ALIVE")
	this:RegisterEvent("TIME_PLAYED_MSG")
	this:RegisterEvent("UPDATE_SHAPESHIFT_FORMS")
	this:RegisterEvent("UNIT_SPELLCAST_START")
	this:RegisterEvent("UNIT_SPELLCAST_STOP")
	this:RegisterEvent("UNIT_SPELLCAST_FAILED")
	this:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED")
	this:RegisterEvent("UNIT_SPELLCAST_DELAYED")
	this:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
	this:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
	this:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE")
	this:RegisterEvent("UNIT_HAPPINESS")
	this:RegisterEvent("INSPECT_TALENT_READY")
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("VOICE_START")
	this:RegisterEvent("VOICE_STOP")
	this:RegisterEvent("READY_CHECK")
	this:RegisterEvent("READY_CHECK_CONFIRM")
	this:RegisterEvent("READY_CHECK_FINISHED")
	this:RegisterEvent("RAID_TARGET_UPDATE")
	this:RegisterEvent("ZONE_CHANGED")
end


--|  First load setup maintanence.  Generaly Blizzard stuff  |--

function Sui_Setup()
	SetCVar("cameraDistanceMax","50")								-- Set the max cam distance to max
	SetCVar("cameraYawMoveSpeed","230")								-- Reset SpinCam in case of poor reload
	
	ChatFrame1:UnregisterEvent("TIME_PLAYED_MSG")
	RequestTimePlayed()
	
	SUI_MinimapCoords:SetWidth(100)									-- Limit the width of the coordinate textbox
	
	MainMenuBar:Hide()
	SUI_HUD:SetFrameLevel(1)
	
	QuestWatchFrame:ClearAllPoints()
	QuestWatchFrame:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOMRIGHT", -20, 200)
	QuestTimerFrame:ClearAllPoints()
	QuestTimerFrame:SetPoint("BOTTOM", "UIParent", "BOTTOM", 0, 250)
	DurabilityFrame:ClearAllPoints()
	DurabilityFrame:SetPoint("BOTTOM", "SUI_MapOverlay", "TOP", 0, 0)
	
	--|  Size down the minimap clock icon  |--
	GameTimeFrame:SetScale(0.85)
	local point, relativeTo, relativePoint, xOfs, yOfs = GameTimeFrame:GetPoint()
	GameTimeFrame:SetParent(Minimap)
	GameTimeFrame:SetFrameLevel(5)
	GameTimeFrame:SetPoint(point, "Minimap", relativePoint, 0, 0)
	
	--|  Hide Unit frames and add redundancy for if SUI doesnt catch it fast enough  |--
	PlayerFrame:Hide()
	TargetFrame:SetAlpha(0)
	PartyMemberFrame1:SetAlpha(0)
	PartyMemberFrame2:SetAlpha(0)
	PartyMemberFrame3:SetAlpha(0)
	PartyMemberFrame4:SetAlpha(0)
	BuffFrame:Hide()
	BuffFrame:SetAlpha(0)
	
	hooksecurefunc("updateContainerFrameAnchors", Sui_Bags)
	hooksecurefunc("CaptureBar_Update", Sui_CaptureBar_Update)
	hooksecurefunc("UIParent_ManageFramePositions", Sui_ManageFrames)
	
	if ( BattlefieldMinimapTab and not BattlefieldMinimapTab:IsUserPlaced() ) then
		BattlefieldMinimapTab:ClearAllPoints()
		BattlefieldMinimapTab:SetPoint("TOP", "UIParent", "TOP", 0, 0)
	end

	if (Adapt) then
		Adapt_Settings.Shape = "SQUARE"
		Adapt.Reshape()
		Adapt_Settings.Back = Adapt_Settings.Back=="OFF"
		Adapt.Reback()
	end
end

--|  Hooked Blizzard code.  Moves items including the quest frame to fit the new layout  |--

function Sui_ManageFrames()
	QuestWatchFrame:ClearAllPoints()
	QuestWatchFrame:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOMRIGHT", -20, 200)
	QuestTimerFrame:ClearAllPoints()
	QuestTimerFrame:SetPoint("BOTTOM", "UIParent", "BOTTOM", 0, 250)
	DurabilityFrame:ClearAllPoints()
	DurabilityFrame:SetPoint("BOTTOM", "SUI_MapOverlay", "TOP", 0, 0)
	
	if ( NUM_EXTENDED_UI_FRAMES ) then
		local captureBar
		local numCaptureBars = 0
		for i=1, NUM_EXTENDED_UI_FRAMES do
			captureBar = getglobal("WorldStateCaptureBar"..i)
			if ( captureBar and captureBar:IsShown() ) then
				captureBar:SetPoint("BOTTOMRIGHT", "QuestWatchFrame", "TOPRIGHT", 0, 20)
			end
		end	
	end
end

function Sui_CaptureBar_Update(id, value, neutralPercent)
	DEFAULT_CHAT_FRAME:AddMessage("id: "..id.." | value: "..value, 0.5, 0.5, 0.5)
	local bar = getglobal("WorldStateCaptureBar"..id)
	bar:ClearAllPoints()
	bar:SetPoint("CENTER", "UIParent", "CENTER", 0, 200)
	DEFAULT_CHAT_FRAME:AddMessage("Move attempted", 0.5, 0.5, 0.5)
end


--| This could be shortened... a lot  |--
function Sui_Bags()
	local frame, xOffset, yOffset, screenHeight, freeScreenHeight, leftMostPoint, column
	local screenWidth = GetScreenWidth()
	local containerScale = 1
	local leftLimit = 0
	if ( BankFrame:IsShown() ) then
		leftLimit = BankFrame:GetRight() - 25
	end
	
	while ( containerScale > CONTAINER_SCALE ) do
		screenHeight = GetScreenHeight() / containerScale
		-- Adjust the start anchor for bags depending on the multibars
		xOffset = 1 / containerScale 
		yOffset = 155 
		-- freeScreenHeight determines when to start a new column of bags
		freeScreenHeight = screenHeight - yOffset
		leftMostPoint = screenWidth - xOffset
		column = 1
		local frameHeight
		for index, frameName in ipairs(ContainerFrame1.bags) do
			frameHeight = getglobal(frameName):GetHeight()
			if ( freeScreenHeight < frameHeight ) then
				-- Start a new column
				column = column + 1
				leftMostPoint = screenWidth - ( column * CONTAINER_WIDTH * containerScale ) - xOffset
				freeScreenHeight = screenHeight - yOffset
			end
			freeScreenHeight = freeScreenHeight - frameHeight - VISIBLE_CONTAINER_SPACING
		end
		if ( leftMostPoint < leftLimit ) then
			containerScale = containerScale - 0.01
		else
			break
		end
	end
	
	if ( containerScale < CONTAINER_SCALE ) then
		containerScale = CONTAINER_SCALE
	end
	
	screenHeight = GetScreenHeight() / containerScale
	-- Adjust the start anchor for bags depending on the multibars
	xOffset = 1 / containerScale
	yOffset = 160
	-- freeScreenHeight determines when to start a new column of bags
	freeScreenHeight = screenHeight - yOffset
	column = 0
	for index, frameName in ipairs(ContainerFrame1.bags) do
		frame = getglobal(frameName)
		frame:SetScale(containerScale)
		if ( index == 1 ) then
			-- First bag
			frame:SetPoint("BOTTOMRIGHT", frame:GetParent(), "BOTTOMRIGHT", -xOffset, yOffset )
		elseif ( freeScreenHeight < frame:GetHeight() ) then
			-- Start a new column
			column = column + 1
			freeScreenHeight = screenHeight - yOffset
			frame:SetPoint("BOTTOMRIGHT", frame:GetParent(), "BOTTOMRIGHT", -(column * CONTAINER_WIDTH) - xOffset, yOffset )
		else
			-- Anchor to the previous bag
			frame:SetPoint("BOTTOMRIGHT", ContainerFrame1.bags[index - 1], "TOPRIGHT", 0, CONTAINER_SPACING)	
		end
		freeScreenHeight = freeScreenHeight - frame:GetHeight() - VISIBLE_CONTAINER_SPACING
	end
end

function Sui_MinimapFix()
	MinimapBorderTop:Hide()
	MinimapToggleButton:Hide()
	MinimapBorder:Hide()
	Minimap:SetHeight(154)
	Minimap:SetWidth(154)
	Minimap:ClearAllPoints()
	Minimap:SetPoint("CENTER", "SUI_MapOverlay", "CENTER", 0, 0)
	MinimapCluster:ClearAllPoints()
	MinimapCluster:SetPoint("CENTER", "SUI_MapOverlay", "CENTER", -10, -4)
	MinimapZoneText:ClearAllPoints()
	MinimapZoneText:SetParent(Minimap)
	MinimapZoneText:SetPoint("BOTTOM", "SUI_MapOverlay", "BOTTOM", 0, 24)
	MinimapZoneTextButton:ClearAllPoints()
	MinimapZoneTextButton:SetPoint("BOTTOM", "MinimapZoneText", "BOTTOM", 0, 0)
	-- MinimapZoneText:SetFontObject(SUI_Multilingual)
	-- SUI_MinimapCoords:SetFontObject(SUI_Multilingual)
	
	-- Bug fix for evil addons that mess things up
	MinimapZoomIn:SetParent(Minimap)
	MinimapZoomOut:SetParent(Minimap)
	MiniMapTracking:SetParent(Minimap)
	MiniMapWorldMapButton:SetParent(Minimap)
end

function Sui_ChatFrame(task)
	if task=="setup" then
		local strata = "LOW"
		ChatFrame1:SetFrameStrata(strata)
		ChatFrame2:SetFrameStrata(strata)
		ChatFrame3:SetFrameStrata(strata)
		ChatFrame4:SetFrameStrata(strata)
		ChatFrame5:SetFrameStrata(strata)
		ChatFrame6:SetFrameStrata(strata)
		ChatFrame7:SetFrameStrata(strata)
		ChatFrameEditBox:ClearAllPoints()
		ChatFrameEditBox:SetPoint("BOTTOMLEFT", "ChatFrame1", "TOPLEFT", 0, 2)
		ChatFrameEditBox:SetPoint("BOTTOMRIGHT", "ChatFrame1", "TOPRIGHT", 0, 2)
		ChatFrameMenuButton:SetFrameStrata("DIALOG")
		-- ChatFrameMenuButton:SetPoint("BOTTOM", "ChatFrame1UpButton", "TOP", 0, 0)
		ChatFrame1BottomButton:SetPoint("BOTTOMLEFT", "ChatFrame1", "BOTTOMRIGHT", -32, -4)
		ChatFrame2BottomButton:SetPoint("BOTTOMLEFT", "ChatFrame2", "BOTTOMRIGHT", -32, -4)
		ChatFrame3BottomButton:SetPoint("BOTTOMLEFT", "ChatFrame3", "BOTTOMRIGHT", -32, -4)
		ChatFrame4BottomButton:SetPoint("BOTTOMLEFT", "ChatFrame4", "BOTTOMRIGHT", -32, -4)
		ChatFrame5BottomButton:SetPoint("BOTTOMLEFT", "ChatFrame5", "BOTTOMRIGHT", -32, -4)
		ChatFrame6BottomButton:SetPoint("BOTTOMLEFT", "ChatFrame6", "BOTTOMRIGHT", -32, -4)
		ChatFrame7BottomButton:SetPoint("BOTTOMLEFT", "ChatFrame7", "BOTTOMRIGHT", -32, -4)
		
		local scale=0.8
		local i = 1
		while i < 8 do
			_G["ChatFrame"..i.."BottomButton"]:SetScale(scale)
			_G["ChatFrame"..i.."DownButton"]:SetScale(scale)
			_G["ChatFrame"..i.."UpButton"]:SetScale(scale)
			i = i + 1
		end
		ChatFrameMenuButton:SetScale(scale)
		
	elseif task=="hide" then
		ChatFrameMenuButton:SetAlpha(0)
		ChatFrame1UpButton:SetAlpha(0)
		ChatFrame1DownButton:SetAlpha(0)
		ChatFrame1BottomButton:SetAlpha(0)
		ChatFrame2UpButton:SetAlpha(0)
		ChatFrame2DownButton:SetAlpha(0)
		ChatFrame2BottomButton:SetAlpha(0)
		ChatFrame3UpButton:SetAlpha(0)
		ChatFrame3DownButton:SetAlpha(0)
		ChatFrame3BottomButton:SetAlpha(0)
		ChatFrame4UpButton:SetAlpha(0)
		ChatFrame4DownButton:SetAlpha(0)
		ChatFrame4BottomButton:SetAlpha(0)
		ChatFrame5UpButton:SetAlpha(0)
		ChatFrame5DownButton:SetAlpha(0)
		ChatFrame5BottomButton:SetAlpha(0)
		ChatFrame6UpButton:SetAlpha(0)
		ChatFrame6DownButton:SetAlpha(0)
		ChatFrame6BottomButton:SetAlpha(0)
		ChatFrame7UpButton:SetAlpha(0)
		ChatFrame7DownButton:SetAlpha(0)
		ChatFrame7BottomButton:SetAlpha(0)
	elseif task=="show" then
		ChatFrameMenuButton:SetAlpha(1)
		ChatFrame1UpButton:SetAlpha(1)
		ChatFrame1DownButton:SetAlpha(1)
		ChatFrame1BottomButton:SetAlpha(1)
		ChatFrame2UpButton:SetAlpha(1)
		ChatFrame2DownButton:SetAlpha(1)
		ChatFrame2BottomButton:SetAlpha(1)
		ChatFrame3UpButton:SetAlpha(1)
		ChatFrame3DownButton:SetAlpha(1)
		ChatFrame3BottomButton:SetAlpha(1)
		ChatFrame4UpButton:SetAlpha(1)
		ChatFrame4DownButton:SetAlpha(1)
		ChatFrame4BottomButton:SetAlpha(1)
		ChatFrame5UpButton:SetAlpha(1)
		ChatFrame5DownButton:SetAlpha(1)
		ChatFrame5BottomButton:SetAlpha(1)
		ChatFrame6UpButton:SetAlpha(1)
		ChatFrame6DownButton:SetAlpha(1)
		ChatFrame6BottomButton:SetAlpha(1)
		ChatFrame7UpButton:SetAlpha(1)
		ChatFrame7DownButton:SetAlpha(1)
		ChatFrame7BottomButton:SetAlpha(1)
	end
end


function Sui_ChatToggle()
	if (not SUI_chatToggle) or (SUI_chatToggle==0) then
		SUI_chatToggle = ChatFrame1:GetHeight()
		ChatFrame1:SetHeight(500)
	else
		ChatFrame1:SetHeight(SUI_chatToggle)
		SUI_chatToggle=0
	end
end


--|  Bartender Setup |--

local function tblMerge(source, dest)
	if type(source) ~= "table" then return end
	if type(dest) ~= "table" then dest = {} end
	for k,v in pairs(source) do
		if type(v) ~= "table" then
			dest[k] = v
		else
			dest[k] = tblMerge(v, dest[k])
		end
	end
	return dest
end



function Sui_Bartender()
	Bartender3:SetProfile("SpartanUI_Standard_2.3117")
	local CustomConfig = {
		Bars = {
			[1] = {
				PosX = -130,
				PosY = 90,
				Style = "Zoomed",
				Padding = 5,
				Scale = 0.81,
				StatesEnabled = true,
				Possess = true,
				Stances = {
					-- warrior
					battle  = "7",
					def = "8",
					berserker = "9",
					-- druid
					bear = "9",
					cat = "7",
					prowl = "8",
					-- rogue
					stealth = "7",
				},
			},
			[2] = {
				Enabled = false,
				PosX = 300,
				PosY = 300,
			},
			[3] = {
				Rows = 1,
				PosX = 0,
				PosY = 0,
				Style = "Zoomed",
				Padding = 5,
				Scale = 0.81
			},
			[4] = {
				Rows = 1,
				PosX = 0,
				PosY = 0,
				Style = "Zoomed",
				Padding = 5,
				Scale = 0.81
			},
			[5] = {
				Rows = 1,
				PosX = 0,
				PosY = 0,
				Style = "Zoomed",
				Padding = 5,
				Scale = 0.81
			},
			[6] = {
				Enabled = true,
				Rows = 3,
				PosX = 0,
				PosY = 0,
				Style = "Dreamlayout",
				Padding = 0,
				Scale = 0.9
			},
			[7] = {
				Enabled = false,
				PosX = 300,
				PosY = 300,
			},
			[8] = {
				Enabled = false,
				PosX = 300,
				PosY = 300,
			},
			[9] = {
				Enabled = false,
				PosX = 300,
				PosY = 300,
			},
			[10] = {
				Enabled = true,
				Rows = 3,
				PosX = 0,
				PosY = 0,
				Style = "Dreamlayout",
				Padding = 0,
				Scale = 0.9
			},
		},
		SpecialBars = {
			["STANCE"] = {
				Scale = 0.9,
				PosX = 0,
				PosY = 0,
				FadeOut = false,
				Enabled = true,
			},
			["PET"] = {
				Scale = 0.9,
				PosX = 0,
				PosY = 0,
				FadeOut = false,
				Enabled = true,
			},
			["MICROMENU"] = {
				Padding = 0,
				Style = "Default",
				Scale = 0.8,
				FadeOut = false,
				PosX = 0,
				PosY = 0,
			},
			["BAGS"] = {
				Padding = 3,
				Keyring = true,
				OneBag = false,
				Scale = 0.7,
				Style = "Zoomed",
				FadeOut = false,
				PosX = 0,
				PosY = 0,
			},
			["XP"] = {
				Enabled = false,
				Hide = true,
				Style = "Default",
				PosX = 0,
				PosY = -900,
			},
			["REPUTATION"] = {
				Enabled = false,
				Hide = true,
				Style = "Default",
				PosX = 0,
				PosY = -900,
			},
			["ROLL"] = {
				Style = "Default",
				Enabled = false,
				PosX = 0,
				PosY = 0,
			},
		},
		Tooltip = "enabled",
		SelfCastModifier = true,
		SelfCastRightClick = false,
		ButtonLock = false,
		OutOfRange = true,
		Colors = { OutOfRange = { r = 0.8, g = 0.1, b = 0.1 }, OutOfMana = { r = 0.5, g = 0.5, b = 1.0 } },
		Sticky = true,
	}
	
	
	local db = Bartender3.db.profile
	if not db.CustomUI then
		db.CustomUI = true
		tblMerge(CustomConfig, db)
	end

	Bartender3:RefreshBars()
	Bartender3:OnProfileEnable()
	Bartender3:RefreshBars()
end


-----------------------------------------------------------------------------------------------
--|  Purpose:	Bartender re-anchors its frames after each setup.  This detaches them and	|--
--|				places them in their correct positions (if they exist).						|--

function Sui_BarFix()
	if not Bartender3_Plate then
		local f = CreateFrame("Frame","Bartender3_Plate", SpartanUI)
		f:SetFrameStrata("LOW")
		f:SetWidth(512)
		f:SetHeight(512)
		f:SetPoint("BOTTOM",0,0)
		f:Show()
		
    	Minimap:SetParent(SpartanUI)
    end
	
	if BT3Bar1 then
		BT3Bar1:ClearAllPoints()
		BT3Bar1:SetPoint("BOTTOMRIGHT", "SpartanUI", "BOTTOM", -124, 87)
		
		SUI_Bar1_BG:ClearAllPoints()
		SUI_Bar1_BG:Show()
		SUI_Bar1_BG:SetPoint("BOTTOMLEFT", "BT3Bar1", "BOTTOMLEFT", -55, -15)
		BT3Bar1:SetParent(Bartender3_Plate)
	else
		SUI_Bar1_BG:Hide()
	end
	
	if BT3Bar2 then
		BT3Bar2:ClearAllPoints()
		-- DEFAULT_CHAT_FRAME:AddMessage("Bar2 reset", 0.65, 0.65, 0.65)	
	end
	
	if BT3Bar3 then
		BT3Bar3:ClearAllPoints()
		BT3Bar3:SetPoint("BOTTOMRIGHT", "SpartanUI", "BOTTOM", -124, 39)
		
		SUI_Bar2_BG:ClearAllPoints()
		SUI_Bar2_BG:Show()
		SUI_Bar2_BG:SetPoint("BOTTOMLEFT", "BT3Bar3", "BOTTOMLEFT", -55, -15)
		BT3Bar3:SetParent(Bartender3_Plate)
	else
		SUI_Bar2_BG:Hide()
	end
	
	if BT3Bar4 then
		BT3Bar4:ClearAllPoints()
		BT3Bar4:SetPoint("BOTTOMLEFT", "SpartanUI", "BOTTOM", 124, 87)
		
		SUI_Bar3_BG:ClearAllPoints()
		SUI_Bar3_BG:Show()
		SUI_Bar3_BG:SetPoint("BOTTOMLEFT", "BT3Bar4", "BOTTOMLEFT", -55, -15)
		BT3Bar4:SetParent(Bartender3_Plate)
	else
		SUI_Bar3_BG:Hide()
	end
	
	if BT3Bar5 then
		BT3Bar5:ClearAllPoints()
		BT3Bar5:SetPoint("BOTTOMLEFT", "SpartanUI", "BOTTOM", 124, 39)
		
		SUI_Bar4_BG:ClearAllPoints()
		SUI_Bar4_BG:Show()
		SUI_Bar4_BG:SetPoint("BOTTOMLEFT", "BT3Bar5", "BOTTOMLEFT", -55, -15)
		BT3Bar5:SetParent(Bartender3_Plate)
	else
		SUI_Bar4_BG:Hide()
    end
	
	if BT3Bar6 then
		BT3Bar6:Show()
		BT3Bar6:ClearAllPoints()
		BT3Bar6:SetPoint("BOTTOMRIGHT", "SpartanUI", "BOTTOM", -560, 4)
		
		SUI_Bar5_BG:ClearAllPoints()
		SUI_Bar5_BG:Show()
		SUI_Bar5_BG:SetPoint("BOTTOMRIGHT", "BT3Bar6", "BOTTOMRIGHT", 61, -12)
		BT3Bar6:SetParent(Bartender3_Plate)
	else
		SUI_Bar5_BG:Hide()
    end
    
	if BT3Bar7 then
		BT3Bar7:ClearAllPoints()
	end
	
	if BT3Bar8 then
		BT3Bar8:ClearAllPoints()
	end
	
	if BT3Bar9 then
		BT3Bar9:ClearAllPoints()
	end
	
	if BT3Bar10 then
		BT3Bar10:Show()
		BT3Bar10:ClearAllPoints()
		BT3Bar10:SetPoint("BOTTOMLEFT", "SpartanUI", "BOTTOM", 560, 4)
		
		SUI_Bar6_BG:ClearAllPoints()
		SUI_Bar6_BG:Show()
		SUI_Bar6_BG:SetPoint("BOTTOMLEFT", "BT3Bar10", "BOTTOMLEFT", -59, -11)
		BT3Bar10:SetParent(Bartender3_Plate)
	else
		SUI_Bar6_BG:Hide()
	end
	
	if BT3BarBAGS then
		BT3BarBAGS:Show()
		BT3BarBAGS:ClearAllPoints()
		BT3BarBAGS:SetPoint("BOTTOMLEFT", "SpartanUI", "BOTTOM", 426, 152)
		BT3BarBAGS:SetParent(Bartender3_Plate)
	end
	
	if BT3BarMICROMENU then
		BT3BarMICROMENU:Show()
		BT3BarMICROMENU:ClearAllPoints()
		BT3BarMICROMENU:SetPoint("BOTTOMLEFT", "SpartanUI", "BOTTOM", 134, 129)
		BT3BarMICROMENU:SetParent(Bartender3_Plate)
	end
	
	if BT3BarPET then
		BT3BarPET:Show()
		BT3BarPET:ClearAllPoints()
		BT3BarPET:SetPoint("BOTTOMRIGHT", "SpartanUI", "BOTTOM", -123, 116)
		BT3BarPET:SetParent(Bartender3_Plate)
	end
	
	if BT3BarSTANCE then
		BT3BarSTANCE:Show()
		BT3BarSTANCE:ClearAllPoints()
		BT3BarSTANCE:SetPoint("BOTTOMRIGHT", "SpartanUI", "BOTTOM", -202, 116)
		BT3BarSTANCE:SetParent(Bartender3_Plate)
	end
	
	if BT3BarXP then
		BT3BarXP:Hide()
	end
end


--|  Dropdown Menus & Click-targeting  |--

function Sui_Dropdown_Setup(father, son, toon)
	local showmenu = function()
		ToggleDropDownMenu(1, nil, son, father, 106, 27)
	end
	SecureUnitButton_OnLoad(this, toon, showmenu)
end

function Sui_DropDown_OnLoad(script)
	UIDropDownMenu_Initialize(this, script, "MENU")
end

function Sui_Self_DropDown_Initialize()
	UnitPopup_ShowMenu(SUI_Self_DropDown, "SELF", "player")
end

function Sui_Pet_DropDown_Initialize()
	UnitPopup_ShowMenu(SUI_Pet_DropDown, "PET", "pet")
end

function SUI_Focus_DropDown_Initialize()
	-- UnitPopup_ShowMenu(SUI_Focus_DropDown, "FOCUS", "focus")
end

function Sui_Party1_DropDown_Initialize()
	local menu = "PARTY"
	local name
	local id = UnitInRaid("party1")
	menu = "PARTY"
	if ( menu ) then
		UnitPopup_ShowMenu(SUI_Party1_DropDown, menu, "party1", name, id)
	end
end

function Sui_Party2_DropDown_Initialize()
	UnitPopup_ShowMenu(SUI_Party2_DropDown, "PARTY", "party2")
end

function Sui_Party3_DropDown_Initialize()
	UnitPopup_ShowMenu(SUI_Party3_DropDown, "PARTY", "party3")
end
function Sui_Party4_DropDown_Initialize()
	UnitPopup_ShowMenu(SUI_Party4_DropDown, "PARTY", "party4")
end

function Sui_Target_DropDown_Initialize()
	local menu
	local name
	local id = nil
	if ( UnitIsUnit("target", "player") ) then
		menu = "SELF"
	elseif ( UnitIsUnit("target", "pet") ) then
		menu = "PET"
	elseif ( UnitIsPlayer("target") ) then
		id = UnitInRaid("target")
		if ( id ) then
			menu = "RAID_PLAYER"
			name = GetRaidRosterInfo(id +1)
		elseif ( UnitInParty("target") ) then
			menu = "PARTY"
		else
			menu = "PLAYER"
		end
	else
		menu = "RAID_TARGET_ICON"
		name = RAID_TARGET_ICON
	end
	if ( menu ) then
		UnitPopup_ShowMenu(SUI_Target_DropDown, menu, "target", name, id)
	end
end

function Sui_TOT_DropDown_Initialize()
	local menu
	local name
	local id = nil
	if ( UnitIsUnit("targettarget", "player") ) then
		menu = "SELF"
	elseif ( UnitIsUnit("targettarget", "pet") ) then
		menu = "PET"
	elseif ( UnitIsPlayer("targettarget") ) then
		id = UnitInRaid("targettarget")
		if ( id ) then
			menu = "RAID_PLAYER"
			name = GetRaidRosterInfo(id +1)
		elseif ( UnitInParty("target") ) then
			menu = "PARTY"
		else
			menu = "PLAYER"
		end
	else
		menu = "RAID_TARGET_ICON"
		name = RAID_TARGET_ICON
	end
	if ( menu ) then
		UnitPopup_ShowMenu(SUI_ToT_DropDown, menu, "target", name, id)
	end
end

function Sui_Self_OnReceiveDrag()
	if ( CursorHasItem() ) then
		AutoEquipCursorItem()
	end
end



-----------------------------------------------------------------------------------------------
--|  Purpose:	Generic function for determining and setting the class icon for a unit.		|--
--|  Arguments:	toon = "player", "party1", etc...											|--
--|				texture = name of the healthbar texture object								|--
--|				scale = size of the icon in pixels you want it to be displayed at.			|--

function Sui_ClassIcon(toon, texture, scale)
	local localizedClass, englishClass = UnitClass(toon)
	local column, row, iconsize = 0, 0, 32
	local textDimensions = ((scale/iconsize)*128)
	if englishClass=="WARRIOR" then
		column=1
		row=1
	elseif englishClass=="MAGE" then
		column=2
		row=1
	elseif englishClass=="ROGUE" then
		column=3
		row=1
	elseif englishClass=="DRUID" then
		column=4
		row=1
	elseif englishClass=="HUNTER" then
		column=1
		row=2
	elseif englishClass=="SHAMAN" then
		column=2
		row=2
	elseif englishClass=="PRIEST" then
		column=3
		row=2
	elseif englishClass=="WARLOCK" then
		column=4
		row=2
	elseif englishClass=="PALADIN" then
		column=1
		row=3
	end	
	
	local ULx = (column * iconsize - iconsize) / 128
	local ULy = (row * iconsize - iconsize) / 128
	local LLx = (column * iconsize - iconsize) / 128
	local LLy = (row * iconsize) / 128
	local URx = (column * iconsize) / 128
	local URy = (row * iconsize - iconsize) / 128
	local LRx = (column * iconsize) / 128
	local LRy = (row * iconsize) / 128
	
	texture:SetTexCoordModifiesRect(true)
	texture:SetTexCoord(ULx,ULy,LLx,LLy,URx,URy,LRx,LRy)
	texture:SetHeight(textDimensions)
	texture:SetWidth(textDimensions)
end



-----------------------------------------------------------------------------------------------
--|  Purpose:	Generic function for determining and setting the raid target icons on units.|--
--|  Arguments:	toon = "player", "party1", etc...											|--
--|				texture = name of the healthbar texture object								|--
--|				scale = size of the icon in pixels you want it to be displayed at.			|--

function Sui_RaidIcon(toon, texture, scale)
	local point, relativeTo, relativePoint, xOfs, yOfs = texture:GetPoint()
	local icon = GetRaidTargetIndex(toon)
	local column, row, iconsize = 0, 0, 64
	local textDimensions = ((scale/iconsize)*256)
	if icon==1 then
		column=1
		row=1
	elseif icon==2 then
		column=2
		row=1
	elseif icon==3 then
		column=3
		row=1
	elseif icon==4 then
		column=4
		row=1
	elseif icon==5 then
		column=1
		row=2
	elseif icon==6 then
		column=2
		row=2
	elseif icon==7 then
		column=3
		row=2
	elseif icon==8 then
		column=4
		row=2
	elseif icon==nil then
		column=1
		row=3
	end	

	local ULx = (column * iconsize - iconsize) / 256
	local ULy = (row * iconsize - iconsize) / 256
	local LLx = (column * iconsize - iconsize) / 256
	local LLy = (row * iconsize) / 256
	local URx = (column * iconsize) / 256
	local URy = (row * iconsize - iconsize) / 256
	local LRx = (column * iconsize) / 256
	local LRy = (row * iconsize) / 256
		
	texture:SetTexCoordModifiesRect(true)
	texture:SetTexCoord(ULx,ULy,LLx,LLy,URx,URy,LRx,LRy)
	texture:SetHeight(textDimensions)
	texture:SetWidth(textDimensions)
	texture:GetPoint()
	texture:SetPoint(point , relativeTo, relativePoint, xOfs, yOfs)
end



-----------------------------------------------------------------------------------------------
--|  Purpose:	Generic function for determining and setting the health for unit frames.	|--
--|  Arguments:	toon = "player", "party1", etc...											|--
--|  			barwidth = width of healthbar												|--
--|				percent = name of percentage fontstring										|--
--|				count = name of healthcount fontstring										|--
--|				deficit = name of deficit fontstring										|--
--|				texture = name of the healthbar texture object								|--

function Sui_HealthMath(toon, barwidth, barheight, father)
	-- Name your objects
	local texture = _G[father.."_HealthBar"]
	local percent = _G[father.."_HealthPercentage"]
	local count = _G[father.."_HealthCount"]
	local deficit = _G[father.."_HealthDeficit"]

	-- Divide the current player health by the max, ergo pertentage.
	-- Round the percentage to 0 decimals.
	local toon_Health = (UnitHealth(toon) / UnitHealthMax(toon)) * 100
    local healthPercent = math.floor(toon_Health+0.5)
    
    -- Populate strings
    percent:SetText(healthPercent.."%")
    count:SetText(UnitHealth(toon))
    deficit:SetText(UnitHealthMax(toon) - UnitHealth(toon))
    
    -- Hide count if target health is unretrievable
    if UnitHealthMax(toon)==100 then
    	count:Hide()
    	deficit:Hide()
    else
    	count:Show()
    	deficit:Show()
    end
    
    -- Populate with MobInfo if available
    if toon=="target" and IsAddOnLoaded("MobInfo2")==1 then
    	local mobData = MI2_GetMobData( UnitName("target"), UnitLevel("target"), "target" )
    	if mobData~=nil then
    		count:Show()
    		count:SetText(mobData.healthCur)
    		deficit:SetText(mobData.healthMax - mobData.healthCur)
   		end
    end
    
    -- Hide deficit if there is none
    if (UnitHealthMax(toon) == UnitHealth(toon)) then
    	deficit:Hide()
   	else
    	deficit:Show()
    end
    
    if not texture.barheight then
	    texture.barheight = (barheight * 16)
	    texture.barwidth = (barwidth * 3.2)
    end
    
    if not texture:IsVisible() then
		texture:Show()
	end
	
	-- Pass off global info
	SpartanUI[toon.."_HealthPercent"] = healthPercent
end


-----------------------------------------------------------------------------------------------
--|  Purpose:	Generic function for determining and setting the power for unit frames		|--
--|  Arguments: same as Sui_HealthMath except this time with power							|--

function Sui_PowerMath(toon, barwidth, barheight, father)
	-- Test for power type and configure texture accordingly
	local power, texture2, texture3, texture4
	if UnitPowerType(toon)==0 then
   		power = "Mana"
   		texture2 = _G[father.."_RageBar"]
   		texture3 = _G[father.."_EnergyBar"]
   		texture4 = _G[father.."_FocusBar"]
   		-- DEFAULT_CHAT_FRAME:AddMessage("MANA + t2: Rage, t3: Energy, t4: Focus.  "..toon, 0.5, 0.5, 0.5)
   	elseif UnitPowerType(toon)==1 then
   		power = "Rage"
   		texture2 = _G[father.."_ManaBar"]
   		texture3 = _G[father.."_EnergyBar"]
   		texture4 = _G[father.."_FocusBar"]
   		-- DEFAULT_CHAT_FRAME:AddMessage(" RAGE + t2: Mana, t3: Energy, t4: Focus.  "..toon, 0.5, 0.5, 0.5)
   	elseif UnitPowerType(toon)==2 then
   		power = "Focus"
   		texture2 = _G[father.."_RageBar"]
   		texture3 = _G[father.."_EnergyBar"]
   		texture4 = _G[father.."_ManaBar"]
   		-- DEFAULT_CHAT_FRAME:AddMessage("FOCUS + t2: Rage, t3: Energy, t4: Mana.  "..toon, 0.5, 0.5, 0.5)
   	elseif UnitPowerType(toon)==3 then
   		power = "Energy"
   		texture2 = _G[father.."_RageBar"]
   		texture3 = _G[father.."_ManaBar"]
   		texture4 = _G[father.."_FocusBar"]
   		-- DEFAULT_CHAT_FRAME:AddMessage("ENERGY + t2: Rage, t3: Mana, t4: Focus.  "..toon, 0.5, 0.5, 0.5)
   	end
	
	
	-- Name your objects
	local texture = _G[father.."_"..power.."Bar"]
	local percent = _G[father.."_ManaPercentage"]
	local count = _G[father.."_ManaCount"]
	local deficit = _G[father.."_ManaDeficit"]
	
	-- Divide the current player power by the max, ergo pertentage.
	-- Round the percentage to 0 decimals.
	local power = (UnitMana(toon) / UnitManaMax(toon)) * 100
    local powerPercent = math.floor(power+0.5) + 0
    
    if UnitMana(toon)==0 then
    	powerPercent=0
    end
    
    percent:SetText(powerPercent.."%")
    count:SetText(UnitMana(toon))
    deficit:SetText(UnitManaMax(toon) - UnitMana(toon))
    
    -- Only show the deficit if there is one
    if (UnitManaMax(toon) == UnitMana(toon)) then
    	deficit:Hide()
    else
    	deficit:Show()
    end
    
   	if not texture.barheight then
	    texture.barheight = (barheight * 16)
	    texture.barwidth = (barwidth * 3.2)
    end
	
	if not texture:IsVisible() then
		texture:Show()
		texture2:Hide()
		texture3:Hide()
		texture4:Hide()
	end
	
	-- Pass off global info
	SpartanUI[toon.."_PowerPercent"] = powerPercent
end


-----------------------------------------------------------------------------------------------
--|  Purpose:	Generic function for animating cast bars.									|--
--|  Arguments:	toon = "player", "party1", etc...											|--
--|  			spell = name of the spell being cast										|--
--|				rank = name of the rank (literally ie., "Rank 7")							|--
--|  Logic:		Takes the cast-time of the current spell, and based on the time it started	|--
--|				will determine what percent of the cast has transpired based on the current |--
--|				time.																		|--

function Sui_CastMath(toon, spell, rank, barwidth, barheight, texture)
	local startTime, endTime, spellName
	_, _, SUI_lag = GetNetStats()
	
	if _G[toon.."_isCasting"]==1 then
		spellName, rank, _, _, startTime, endTime, isTradeSkill = UnitCastingInfo(toon)
		if not endTime then
			_G[toon.."_isCasting"]=0
			return
		else
			_G[toon.."diffTime"] = (endTime - startTime)/1000
			_G[toon.."SpellEnd"] = endTime/1000
		end
		if isTradeSkill then
			-- DEFAULT_CHAT_FRAME:AddMessage("You're making "..spellName.." with rank "..rank, 0.65, 0.65, 0.65)
		end
	end
	
	if _G[toon.."_isChanneling"]==1 then
		spellName, _, _, _, startTime, endTime, other = UnitChannelInfo(toon)
		if not endTime then
			_G[toon.."_isChanneling"]=0
			return
		else
			_G[toon.."diffTime"] = (endTime - startTime)/1000
			_G[toon.."SpellEnd"] = endTime/1000
		end
	end
	
	if not texture:IsVisible() then
		texture:Show()
	end
	
	if not texture.barheight then
	    texture.barheight = (barheight * 16)
	    texture.barwidth = (barwidth * 3.2)
    end
	
	if toon=="player" then
		SUI_Self_CastText:SetText(spellName)
		SUI_Self_CastTime:SetText(_G[toon.."diffTime"])
		SUI_Self_CastLatency:SetText(SUI_lag)
		SUI_Self_CastBar_Latency:SetAlpha(.5)
		SUI_Self_CastText:Show()
		SUI_Self_CastTime:Show()
		SUI_Self_CastLatency:Show()
	elseif toon=="party1" then
		SUI_Party1_CastText:SetText(spellName)
		SUI_Party1_CastTime:SetText(_G[toon.."diffTime"])
		SUI_Party1_CastBar_Latency:SetAlpha(.5)
		SUI_Party1_CastText:Show()
		SUI_Party1_CastTime:Show()
		SUI_Party1_CastLatency:Show()
	elseif toon=="party2" then
		SUI_Party2_CastText:SetText(spellName)
		SUI_Party2_CastTime:SetText(_G[toon.."diffTime"])
		SUI_Party2_CastBar_Latency:SetAlpha(.5)
		SUI_Party2_CastText:Show()
		SUI_Party2_CastTime:Show()
		SUI_Party2_CastLatency:Show()
	elseif toon=="party3" then
		SUI_Party3_CastText:SetText(spellName)
		SUI_Party3_CastTime:SetText(_G[toon.."diffTime"])
		SUI_Party3_CastBar_Latency:SetAlpha(.5)
		SUI_Party3_CastText:Show()
		SUI_Party3_CastTime:Show()
		SUI_Party3_CastLatency:Show()
	elseif toon=="party4" then
		SUI_Party4_CastText:SetText(spellName)
		SUI_Party4_CastTime:SetText(_G[toon.."diffTime"])
		SUI_Party4_CastBar_Latency:SetAlpha(.5)
		SUI_Party4_CastText:Show()
		SUI_Party4_CastTime:Show()
		SUI_Party4_CastLatency:Show()
	elseif toon=="target" then
		SUI_Target_CastText:SetText(spellName)
		SUI_Target_CastTime:SetText(_G[toon.."diffTime"])
		SUI_Target_CastBar_Latency:SetAlpha(.5)
		SUI_Target_CastText:Show()
		SUI_Target_CastTime:Show()
		SUI_Target_CastLatency:Show()
	elseif toon=="targettarget" then
		SUI_TOT_CastText:SetText(spellName)
		SUI_TOT_CastTime:SetText(_G[toon.."diffTime"])
		SUI_TOT_CastBar_Latency:SetAlpha(.5)
		SUI_TOT_CastText:Show()
		SUI_TOT_CastTime:Show()
		SUI_TOT_CastLatency:Show()
	elseif toon=="targettargettarget" then
		SUI_TOTT_CastText:SetText(spellName)
		SUI_TOTT_CastTime:SetText(_G[toon.."diffTime"])
		SUI_TOTT_CastBar_Latency:SetAlpha(.5)
		SUI_TOTT_CastText:Show()
		SUI_TOTT_CastTime:Show()
		SUI_TOTT_CastLatency:Show()
	elseif toon=="focus" then
		SUI_Focus_CastText:SetText(spellName)
		SUI_Focus_CastTime:SetText(_G[toon.."diffTime"])
		SUI_Focus_CastBar_Latency:SetAlpha(.5)
		SUI_Focus_CastText:Show()
		SUI_Focus_CastTime:Show()
		SUI_Focus_CastLatency:Show()
	end

	if not _G[toon.."_isCasting"] then
		_G[toon.."_isCasting"]=0
	end
	if not _G[toon.."_isChanneling"] then
		_G[toon.."_isChanneling"]=0
	end
	
	
	if _G[toon.."_isCasting"]==0 and _G[toon.."_isChanneling"]==0 then
		if toon=="player" then
			SUI_Self_CastText:Hide()
			SUI_Self_CastTime:Hide()
			SUI_Self_CastLatency:Hide()
			texture:Hide()
			SUI_Self_CastBar_Latency:Hide()
		elseif toon=="party1" then
			SUI_Party1_CastText:Hide()
			SUI_Party1_CastTime:Hide()
			SUI_Party1_CastLatency:Hide()
			texture:Hide()
			SUI_Party1_CastBar_Latency:Hide()
		elseif toon=="party2" then
			SUI_Party2_CastText:Hide()
			SUI_Party2_CastTime:Hide()
			SUI_Party2_CastLatency:Hide()
			texture:Hide()
			SUI_Party2_CastBar_Latency:Hide()
		elseif toon=="party3" then
			SUI_Party3_CastText:Hide()
			SUI_Party3_CastTime:Hide()
			SUI_Party3_CastLatency:Hide()
			texture:Hide()
			SUI_Party3_CastBar_Latency:Hide()
		elseif toon=="party4" then
			SUI_Party4_CastText:Hide()
			SUI_Party4_CastTime:Hide()
			SUI_Party4_CastLatency:Hide()
			texture:Hide()
			SUI_Party4_CastBar_Latency:Hide()
		elseif toon=="target" then
			SUI_Target_CastText:Hide()
			SUI_Target_CastTime:Hide()
			SUI_Target_CastLatency:Hide()
			texture:Hide()
			SUI_Target_CastBar_Latency:Hide()
		elseif toon=="targettarget" then
			SUI_TOT_CastText:Hide()
			SUI_TOT_CastTime:Hide()
			SUI_TOT_CastLatency:Hide()
			texture:Hide()
			SUI_TOT_CastBar_Latency:Hide()
		elseif toon=="targettargettarget" then
			SUI_TOTT_CastText:Hide()
			SUI_TOTT_CastTime:Hide()
			SUI_TOTT_CastLatency:Hide()
			texture:Hide()
			SUI_TOTT_CastBar_Latency:Hide()
		elseif toon=="focus" then
			SUI_Focus_CastText:Hide()
			SUI_Focus_CastTime:Hide()
			SUI_Focus_CastLatency:Hide()
			texture:Hide()
			SUI_Focus_CastBar_Latency:Hide()
		end
	end
end


-----------------------------------------------------------------------------------------------
--|  Purpose:	Determines actual game time in milliseconds(Blizzard doesnt provide this).  |--
--|  Arguments:	toon = "player", "party1", etc...											|--
--|  Returns:	game time in milliseconds upshifted to seconds decimal (ie., 12345.678)		|--
--|	 Logic:		Finds the difference between system time and game time based on cast start	|--
--|	 			then adds the difference to system time anytime GameTime() is called		|--

function GameTime(toon)
	if not timeDisparity then
		local spellName, startTime, endTime
		spellName, _, _, _, startTime, endTime, other = UnitCastingInfo(toon)
		if not endTime then
			spellName, _, _, _, startTime, endTime, other = UnitChannelInfo(toon)
		end
		timeDisparity = startTime/1000 - GetTime()
	end
	local GameTime = timeDisparity + GetTime()
	
	return GameTime
end


-----------------------------------------------------------------------------------------------
--|  Purpose:	Generic function for animating cast bars. 									|--
--|  Arguments:	toon = "player", "party1", etc...											|--
--|  			barwidth = width of healthbar												|--
--|				percent = name of percentage fontstring										|--

function Sui_CastAnimate(toon)
	local castPercent = 100 - ((_G[toon.."SpellEnd"] - GameTime(toon)) / _G[toon.."diffTime"]) * 100
	
	if (castPercent > 100) then
		castPercent=100
		_G[toon.."_isCasting"]=0
		_G[toon.."_isChanneling"]=0
	end
	
	local castPoint = _G[toon.."SpellEnd"] - GameTime(toon)		-- Time since cast started
	local castPrint = (math.floor((castPoint*10)+0.5)) / 10  	-- the less detailed location for onscreen print
	castPoint = (math.floor((castPoint*1000)+0.5)) / 1000 		-- the highly detailed location of the cast
	
	--|  Latency Bar  |--
	local relativeLag = (SUI_lag/1000) / (_G[toon.."diffTime"])
	
	-- Pass off globals
	SpartanUI[toon.."_CastPercent"] = castPercent
	
	if toon=="player" then
		SUI_Self_CastTime:SetText(string.format("%.1f", castPrint))
		SUI_Self_CastLatency:SetText(SUI_lag)
	elseif toon=="focus" then
		SUI_Focus_CastTime:SetText(string.format("%.1f", castPrint))
		Sui_CastFix(toon, 130, 13, SUI_Focus_CastBar)
	elseif toon=="party1" then
		SUI_Party1_CastTime:SetText(string.format("%.1f", castPrint))
		Sui_CastFix(toon, 120, 14, SUI_Party1_CastBar)
	elseif toon=="party2" then
		SUI_Party2_CastTime:SetText(string.format("%.1f", castPrint))
		Sui_CastFix(toon, 120, 14, SUI_Party2_CastBar)
	elseif toon=="party3" then
		SUI_Party3_CastTime:SetText(string.format("%.1f", castPrint))
		Sui_CastFix(toon, 120, 14, SUI_Party3_CastBar)
	elseif toon=="party4" then
		SUI_Party4_CastTime:SetText(string.format("%.1f", castPrint))
		Sui_CastFix(toon, 120, 14, SUI_Party4_CastBar)
	elseif toon=="target" then
		SUI_Target_CastTime:SetText(string.format("%.1f", castPrint))
		Sui_CastFix(toon, 148, 16, SUI_Target_CastBar)
	elseif toon=="targettarget" then
		SUI_Target_CastTime:SetText(string.format("%.1f", castPrint))
		Sui_CastFix(toon, 148, 16, SUI_Target_CastBar)
	elseif toon=="targettargettarget" then
		SUI_Target_CastTime:SetText(string.format("%.1f", castPrint))
		Sui_CastFix(toon, 148, 16, SUI_Target_CastBar)
	end
end



function Sui_CastFix(toon, barwidth, barheight, texture)
	-- Fix for lack of Blizzard events.
	local spellName, _, _, _, startTime, endTime, other = UnitCastingInfo(toon)
	if endTime then
		_G[toon.."SpellEnd"] = endTime/1000
	else
		_G[toon.."_isCasting"]=0
		spellName, _, _, _, startTime, endTime, other = UnitChannelInfo(toon)
		if endTime then
			_G[toon.."SpellEnd"] = endTime/1000
		else
			_G[toon.."_isChanneling"]=0
		end	
	end
	if _G[toon.."_isCasting"]==0 and _G[toon.."_isChanneling"]==0 then
		Sui_CastMath(toon, arg2, arg3, barwidth, barheight, texture)
	end
end


-----------------------------------------------------------------------------------------------
--|  Purpose:	Generic function for Function for animating bars.							|--
--|  Arguments: toon = player, partyN, target, etc.											|--
--|				type = "Health" or "Power" or "Cast"										|--
--|				texture = target texture name												|--
--|				barwidth = width of the bar to be animated									|--
--|				barheight = height of the bar to be animated								|--
--|				direction = "left" or "right"												|--
--|				smoothdegree = degree to which the smooth slide effect occurs (default 3)	|--

function Sui_Animation(toon, type, texture, barwidth, barheight, direction, smoothdegree)
	-- Identify texture
	if type=="Power" then
		local power
		if UnitPowerType(toon)==0 then
   			power = "Mana"
   		elseif UnitPowerType(toon)==1 then
   			power = "Rage"
   		elseif UnitPowerType(toon)==2 then
   			power = "Focus"
   		elseif UnitPowerType(toon)==3 then
   			power = "Energy"
   		end
   		texture = _G[texture.."_"..power.."Bar"]
   	elseif type=="Health" then
   		texture = _G[texture.."_"..type.."Bar"]
   	end
	
	
    local frameCount = (texture.frameCount or 0) % 40 + 1
    local frameRow = ((frameCount - 1) % 16) + 1
    texture.frameCount = frameCount
    
    if frameCount==1 then
		texture.ColumnCount = 1
	elseif frameCount==17 then
		texture.ColumnCount = 2
	elseif frameCount==33 then
		texture.ColumnCount = 3
	end
	
	if texture.barheight and not texture.dimensionsLoaded then
		texture:SetHeight(texture.barheight)
		texture:SetWidth(texture.barwidth)
		texture.dimensionsLoaded = true
	end
	
	
	-- Declare the variables as needed
	if not (SpartanUI[toon..type]) then
		SpartanUI[toon..type]=0
	elseif not string.find((SpartanUI[toon..type]), "%d+") then
		SpartanUI[toon..type]=0
	end
	
	
	local elementPercent = SpartanUI[toon.."_"..type.."Percent"]
	local toonType = SpartanUI[toon..type]
	local FrameWidth = 0.3125 		-- Which is (1/512) * 160
	local FrameHeight = 0.0625		-- Which is (1/512) * 32
	local deficit = 0
	
	-- Fault protection
	if not elementPercent then
		elementPercent=0
	end
	
	-- Target tapping/tagging
	if (UnitIsTapped("target")) and (not UnitIsTappedByPlayer("target")) then
		local shaderSupported = SUI_Target_HealthBar:SetDesaturated(1)
		if ( not shaderSupported ) then
			SUI_Target_HealthBar:SetVertexColor(0.5, 0.5, 0.5)
		end
	elseif not (UnitIsTapped("target")) then
		SUI_Target_HealthBar:SetDesaturated(nil)
		SUI_Target_HealthBar:SetVertexColor(1, 1, 1)
	end
	
	
	-- Based on type (power or health) takes the percentage and adds to deficit a fraction of the current until it is close enough
	-- This basicly animates the bar making it slide smoothly as changes occur.
	
	if toonType + 0.01 > elementPercent and toonType - 0.01 < elementPercent then
		toonType = elementPercent
	else
		toonType = toonType + ((elementPercent - toonType)/smoothdegree)
	end
	
	deficit = FrameWidth * (toonType * .01)
	
	if direction=="left" then
		local ULx = (FrameWidth * texture.ColumnCount) - FrameWidth
		local ULy = (FrameHeight * frameRow) - FrameHeight
		local LLx = (FrameWidth * texture.ColumnCount) - FrameWidth
		local LLy = (FrameHeight * frameRow)
		local URx = (FrameWidth * texture.ColumnCount) - (FrameWidth - deficit)
		local URy = (FrameHeight * frameRow) - FrameHeight
		local LRx = (FrameWidth * texture.ColumnCount) - (FrameWidth - deficit)
		local LRy = (FrameHeight * frameRow)
		texture:SetTexCoordModifiesRect(true)
		texture:SetTexCoord(ULx,ULy,LLx,LLy,URx,URy,LRx,LRy)
	elseif direction=="right"  then
		local ULx = (FrameWidth * texture.ColumnCount) - (FrameWidth - deficit)
		local ULy = (FrameHeight * frameRow) - FrameHeight
		local LLx = (FrameWidth * texture.ColumnCount) - (FrameWidth - deficit)
		local LLy = (FrameHeight * frameRow)
		local URx = (FrameWidth * texture.ColumnCount - FrameWidth)
		local URy = (FrameHeight * frameRow) - FrameHeight
		local LRx = (FrameWidth * texture.ColumnCount - FrameWidth)
		local LRy = (FrameHeight * frameRow)
		texture:SetTexCoordModifiesRect(true)
		texture:SetTexCoord(ULx,ULy,LLx,LLy,URx,URy,LRx,LRy)
	end
	
	--|  Translate the xOffset to compensate for bottomleft origin
	local point, relativeTo, relativePoint, xOfs, yOfs = texture:GetPoint()
	if direction=="right" then
		direction = (barwidth/160 * 512) -496
	else
		direction = (barwidth - (barwidth/160 * 512) * deficit)
	end

	texture:SetPoint(point, relativeTo, relativePoint, direction, yOfs)
	
	-- Pass off globals
	SpartanUI[toon..type] = toonType
end


function Sui_Crop(texture, top, right, bottom, left, modify, offset)
	local ULx = left
	local ULy = top
	local LLx = left
	local LLy = bottom
	local URx = right
	local URy = top
	local LRx = right
	local LRy = bottom
	texture:SetTexCoordModifiesRect(modify)
	texture:SetTexCoord(ULx,ULy,LLx,LLy,URx,URy,LRx,LRy)
	texture:SetHeight(texture:GetHeight() / (bottom-top)) -- fix cropping bug
	if offset then
		local point, relativeTo, relativePoint, xOfs, yOfs = texture:GetPoint()
		texture:SetPoint(point, relativeTo, relativePoint, xOfs+(texture:GetWidth()-(texture:GetWidth()*(right-left))), yOfs)
	end
		
	-- texture:SetWidth(texture:GetWidth() / (right-left))
	-- SUI_TestString2:SetText("ULx:"..ULx..". ULy:"..ULy..". LLx:"..LLx..". LLy:"..LLy..". URx:"..URx..". URy:"..URy..". LRx:"..LRx..". LRy:"..LRy)
end


function Sui_XP_TooltipVisibility(toggle)
	if toggle=="show" then
		SUI_XP_PortraitModelModel:SetFrameLevel(4)
		SUI_XP_Tooltip:Show()
	elseif toggle=="hide" then
		SUI_XP_Tooltip:Hide()
	end
end

function Sui_XPBar()
	local currentTime, totalTime
	if suiData.currentTime then
		currentTime = suiData.currentTime
		totalTime = suiData.totalTime
	end
	local currentXP, maxXP, restedXP = UnitXP("player"), UnitXPMax("player"), GetXPExhaustion()
	if restedXP==nil then
		restedXP = 0
	elseif (restedXP + currentXP) > maxXP then
		restedXP = maxXP - currentXP
	end
	if currentXP==0 then
		currentXP = 0.1
	end
	
	UIFrameFlash(SUI_XPBarRestedHigh, 0.75, 1.25, -1, true, 0, 0)
	SUI_XPBar:SetWidth((currentXP/maxXP) * 402)
	SUI_XPBarRestedLow:SetWidth(((restedXP+currentXP)/maxXP) * 409)
	SUI_XPBarRestedHigh:SetWidth(((restedXP+currentXP)/maxXP) * 409)
	
	SUI_XP_CurrentXP:SetText("Experience(XP): "..currentXP.."/"..maxXP.."("..math.floor(((currentXP/maxXP)*100)+0.5).."%)")
	SUI_XP_CurrentRested:SetText("Rested XP: "..restedXP.."("..math.floor(((restedXP/maxXP)*100)+0.5).."%)")
	
	if type(currentTime)=="number" then
		local sessionTime = GetTime() - sessionMarker
		local timeSession = (maxXP-currentXP)/(sessionXP/sessionTime)
		local timeLevel = (maxXP-currentXP)/(currentXP/currentTime)
		
		if timeSession < timeLevel then
			estimateTime = timeSession
		else
			estimateTime = timeLevel
		end
		
		local estimateTime = SecondsToTime(estimateTime)
		SUI_XP_EstimatedTime:SetText("Time to level: "..estimateTime)
	end
	if SUI_mobXP then
		SUI_XP_EstimatedMobs:SetText("Mobs to level: "..math.floor(((maxXP-currentXP)/SUI_mobXP) + 0.5).." "..(SUI_mobLast or "Quests"))
	end
	FrameAdvance = 0
end

function Sui_XPIncrease()
	if FrameAdvance==1 then
		SUI_XP_Increase:SetTexCoord( 0, .25, 0, 1)
	elseif FrameAdvance== 2 then
		SUI_XP_Increase:SetTexCoord( .25, .50, 0, 1)
	elseif FrameAdvance== 3 then
		SUI_XP_Increase:SetTexCoord( .50, .75, 0, 1)
	elseif FrameAdvance== 4 then
		SUI_XP_Increase:SetTexCoord( .75, 1, 0, 1)
	end
end


function Sui_Rep_TooltipVisibility(toggle)
	if toggle=="show" then
		local description
		suiData.factionIndex, description = Sui_FindFactionIndex()
		SUI_Rep_Tooltip_Description:SetText(description or " ")		
		SUI_Rep_Tooltip:Show()
	elseif toggle=="hide" then
		SUI_Rep_Tooltip:Hide()
	end
end

function Sui_FindFactionIndex()
	local factionIndex = 1
	while factionIndex do
		local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, isWatched = GetFactionInfo(factionIndex)
		if name then
			if not isWatched then
				factionIndex = factionIndex + 1
			else
				factionIndex = nil
				return factionIndex, description
			end
		else
			factionIndex=nil
		end
	end
end

function Sui_RepBar()
	local RepName, RepReaction, minRep, maxRep, currentRep = GetWatchedFactionInfo()
		
		if minRep < 0 then
			maxRep = maxRep * (-1)
			minRep = minRep * (-1)
			currentRep = currentRep * (-1)
		end
		
		if maxRep < minRep or maxRep==0 then
			local tempvar = maxRep
			maxRep = minRep
			minRep = tempvar
		end
			
		local Reputation = (currentRep - minRep)/(maxRep - minRep) * 402
		
		if Reputation==0 then
			Reputation = 0.1
		end
		
		if Reputation < 0 then
			Reputation = Reputation * (-1)
		end
		
		if not string.find(Reputation, "%d+") then
			Reputation = 1
		end
		
		if Reputation > 402 then
			Reputation = 402
		end
		
		SUI_RepBar:SetWidth(Reputation)
		SUI_RepBarLow:SetWidth(Reputation)
		SUI_RepBarLow2:SetWidth(Reputation)
		
		SUI_RepBar:SetVertexColor(0, 1, 0)
		SUI_RepBarLow:SetVertexColor(0, 1, 0)
		SUI_RepBarLow2:SetVertexColor(0, 1, 0)
		SUI_RepBarLow2:SetAlpha(0.5)
		SUI_RepBar_Lead:SetVertexColor(0, 1, 0)
		SUI_RepBar_LeadLow:SetVertexColor(0, 1, 0)
		SUI_RepBar_LeadLow2:SetVertexColor(0, 1, 0)
		
		local repTitle = "unknown"
		local unknown = "|c00808080 |r"
		local hated = "|c008c0000Hated|r"
		local hostile = "|c00ff0000Hostile|r"
		local unfriendly = "|c00ff8c00Unfriendly|r"
		local nuetral = "|c00bfbfbfNuetral|r"
		local friendly = "|c00ffffffFriendly|r"
		local honored = "|c0000ff00Honored|r"
		local revered = "|c004066e5Revered|r"
		local exalted = "|c009933ccExalted|r"
		
		if RepReaction==0 then
			repTitle=unknown
		elseif RepReaction==1 then
			repTitle=hated
		elseif RepReaction==2 then
			repTitle=hostile
		elseif RepReaction==3 then
			repTitle=unfriendly
		elseif RepReaction==4 then
			repTitle=nuetral
		elseif RepReaction==5 then
			repTitle=friendly
		elseif RepReaction==6 then
			repTitle=honored
		elseif RepReaction==7 then
			repTitle=revered
		elseif RepReaction==8 then
			repTitle=exalted
		end
		
		local relCur = currentRep-minRep
		local relMax = maxRep-minRep
		local relPer = math.floor((relCur/relMax)*100)
		if relCur==0 and relMax==0 then
			relPer = 0
		end
		
		SUI_Rep_Tooltip_Faction:SetText(RepName or "No Faction")
		SUI_Rep_Tooltip_Standing:SetText(repTitle)
		SUI_Rep_Tooltip_Count:SetText(relCur.."/"..relMax.." ("..relPer.."\%)")	

	-- SUI_MouseTooltip_Text:SetText("|c00ffb400RepName:|r"..(RepName or "noname").."\r|c00ffb400RepReaction:|r"..RepReaction.."\r|c00ffb400minRep:|r"..minRep.."\r|c00ffb400maxRep:|r"..maxRep.."\r|c00ffb400currentRep|r"..currentRep.."\r|c00ffb400CurrentFaction:|r"..(suiData.currentFaction or "none").."\r|c00ffb400Reputation:|r"..(Reputation or "none") )
	-- SUI_MouseTooltip:Show()
end



--|  Setup unit frames.  |--

function Sui_SetupMembers(toon, task)
	if toon=="player" or toon=="all" then
		if task=="setup" then
			SUI_Self_Name:SetText(UnitName("player"))														-- Insert the name of the player
			SUI_Self_Level:SetText(UnitLevel("player"))														-- Insert the level of the player
			SetPortraitTexture(SUI_Self_Portrait,"player")													-- Insert the portrait texture of the player
		
			Sui_RaidIcon("player", SUI_Self_RaidIcon, 40)
			Sui_ClassIcon("player", SUI_Self_ClassIcon, 20)
			Sui_HealthMath("player", 148, 16, "SUI_Self")
    		Sui_PowerMath("player", 155, 15, "SUI_Self")
    		
    		SUI_XP_Name:SetText(UnitName("player"))
    		SUI_XP_Name:SetTextColor(1, 0.65, 0)
			SetPortraitTexture(SUI_XP_Portrait,"player")
			SUI_XP_CurrentLevel:SetText("Level: "..UnitLevel("player"))
    		
    	elseif task=="update" then
    		Sui_HealthMath("player", 148, 16, "SUI_Self")
    		Sui_PowerMath("player", 155, 15, "SUI_Self")
    	end
	end
	if toon=="pet" or toon=="all" then
		if task=="setup" then
			if UnitExists("pet") then
				SUI_Pet:Show()
				SUI_Pet_Name:SetText(UnitName("pet"))														-- Insert the name of the pet
				if UnitName("pet")==UNKNOWNOBJECT then
					SendAddonMessage("SUI", "find "..UnitName("player").." petname".." ".."unknown", "WHISPER", UnitName("player"))
				end
				SUI_Pet_Level:SetText(UnitLevel("pet"))														-- Insert the level of the pet
				SetPortraitTexture(SUI_Pet_Portrait,"pet")													-- Insert the portrait texture of the pet
		
				Sui_RaidIcon("pet", SUI_Pet_RaidIcon, 40)
				Sui_ClassIcon("pet", SUI_Pet_ClassIcon, 20)
				local localizedClass, englishClass = UnitClass("player")		
				if englishClass=="HUNTER" then
					SUI_Pet_HappinessIcon:Show()
				end
				
				Sui_HealthMath("pet", 130, 13, "SUI_Pet")
    			Sui_PowerMath("pet", 130, 13, "SUI_Pet")
    		else
    			SUI_Pet:Hide()
    		end
    	elseif task=="update" then
    		local point, relativeTo, relativePoint, xOfs, yOfs = SUI_Pet_HealthBar:GetPoint()
			-- SUI_TestString2:SetText("Bar Coords: "..xOfs..","..yOfs)
    		Sui_HealthMath("pet", 130, 13, "SUI_Pet")
    		Sui_PowerMath("pet", 130, 13, "SUI_Pet")
    	end
	end
	if toon=="focus" or toon=="all" then
		if task=="setup" then
			if UnitExists("focus") then
				SUI_Focus:Show()
				SUI_Focus_Name:SetText(UnitName("focus"))														-- Insert the name of the pet
				SUI_Focus_Level:SetText(UnitLevel("focus"))														-- Insert the level of the pet
				SetPortraitTexture(SUI_Focus_Portrait,"focus")													-- Insert the portrait texture of the pet
				local color = GetDifficultyColor(UnitLevel("target"))
				SUI_Focus_Level:SetTextColor(color.r, color.g, color.b)
		
				Sui_RaidIcon("focus", SUI_Focus_RaidIcon, 40)
				Sui_ClassIcon("focus", SUI_Focus_ClassIcon, 20)
				Sui_HealthMath("focus", 130, 13, "SUI_Focus")
    			-- Sui_PowerMath("focus", 130, 13, "SUI_Focus")
    		else
    			SUI_Focus:Hide()
    		end
    	elseif task=="update" then
    		Sui_HealthMath("focus", 130, 13, "SUI_Focus")
    		-- Sui_PowerMath("focus", 130, 13, "SUI_Focus")
    	end
	end
	if toon=="target" or toon=="all" then
		if task=="setup" then
			if UnitExists("target") then
				SUI_TargetFrame:Show()
							
				SUI_Target_Name:SetText(UnitName("target"))
				SUI_Target_Level:SetText(UnitLevel("target"))
				if UnitLevel("target")==(-1) then
				end
					
				local color = GetDifficultyColor(UnitLevel("target"))
				SUI_Target_Level:SetTextColor(color.r, color.g, color.b)
				
				SetPortraitTexture(SUI_Target_Portrait,"target")
				if UnitClassification("target")=="normal" then
					SUI_Target_EliteIcon:Hide()
				elseif UnitClassification("target")=="rare" or UnitClassification("target")=="rareelite" then
					SUI_Target_EliteIcon:SetTexture("Interface\\AddOns\\SpartanUI\\Textures\\Icon_Elite.blp")
					SUI_Target_EliteIcon:Show()
				elseif UnitClassification("target")=="worldboss" or UnitClassification("target")=="elite" then
					SUI_Target_EliteIcon:SetTexture("Interface\\AddOns\\SpartanUI\\Textures\\Icon_Elite.blp")
					SUI_Target_EliteIcon:Show()
				end
				
				Sui_GetSpec("target")
				Sui_RaidIcon("target", SUI_Target_RaidIcon, 40)
				Sui_ClassIcon("target", SUI_Target_ClassIcon, 20)
    			Sui_HealthMath("target", 148, 16, "SUI_Target")
    			Sui_PowerMath("target", 155, 15, "SUI_Target")
			else
				SUI_TargetFrame:Hide()
				SUI_Target_EliteIcon:Hide()
    		end
    	elseif task=="update" then
    		Sui_HealthMath("target", 148, 16, "SUI_Target")
    		Sui_PowerMath("target", 155, 15, "SUI_Target")
    	end
    end
    
    if toon=="targettarget" or toon=="all" then
		if task=="setup" then
			if UnitExists("targettarget") then
				SUI_TOT:Show()
							
				SUI_TOT_Name:SetText(UnitName("targettarget"))
				SUI_TOT_Level:SetText(UnitLevel("targettarget"))
				local color = GetDifficultyColor(UnitLevel("targettarget"))
				SUI_TOT_Level:SetTextColor(color.r, color.g, color.b)
				
				SetPortraitTexture(SUI_TOT_Portrait,"targettarget")
				
				Sui_RaidIcon("targettarget", SUI_TOT_RaidIcon, 40)
				Sui_ClassIcon("targettarget", SUI_TOT_ClassIcon, 20)
    			Sui_HealthMath("targettarget", 120, 15, "SUI_TOT")
    			Sui_PowerMath("targettarget", 136, 14, "SUI_TOT")
			else
				SUI_TOT:Hide()
    		end
    	elseif task=="update" then
    		Sui_HealthMath("targettarget", 120, 15, "SUI_TOT")
    		Sui_PowerMath("targettarget", 136, 14, "SUI_TOT")
    	end
    end
    
    if toon=="party1" or toon=="all" then
    	if task=="setup" then
			PartyMemberFrame1:Hide()
			if ( not UnitExists("party1") ) then
				SUI_Party1:Hide()
			else
				SUI_Party1:Show()
				SUI_Party1_Name:SetText(UnitName("party1"))
				SUI_Party1_Level:SetText(UnitLevel("party1"))
				SetPortraitTexture(SUI_Party1_Portrait,"party1")			
				Sui_RaidIcon("party1", SUI_Party1_RaidIcon, 30)
				Sui_ClassIcon("party1", SUI_Party1_ClassIcon, 20)
    			Sui_HealthMath("party1", 120, 15, "SUI_Party1")
    			Sui_PowerMath("party1", 136, 14, "SUI_Party1")
    		end
    		if suiData.partyToggle=="off" then
    			SUI_Party1:Hide()
    		end
    	elseif task=="update" then
    		Sui_HealthMath("party1", 120, 15, "SUI_Party1")
    		Sui_PowerMath("party1", 136, 14, "SUI_Party1")
    	end
    end
    if (toon=="party2" or toon=="all") then
    	if task=="setup" then
    		PartyMemberFrame2:Hide()
			if ( not UnitExists("party2") ) then
				SUI_Party2:Hide()
			else
				SUI_Party2:Show()
							
				SUI_Party2_Name:SetText(UnitName("party2"))
				SUI_Party2_Level:SetText(UnitLevel("party2"))
				
				SetPortraitTexture(SUI_Party2_Portrait,"party2")			
				Sui_RaidIcon("party2", SUI_Party2_RaidIcon, 30)
				Sui_ClassIcon("party2", SUI_Party2_ClassIcon, 20)
    			Sui_HealthMath("party2", 120, 15, "SUI_Party2")
    			Sui_PowerMath("party2", 136, 14, "SUI_Party2")
    		end
    		if suiData.partyToggle=="off" then
    			SUI_Party2:Hide()
    		end
    	elseif task=="update" then
    		Sui_HealthMath("party2", 120, 15, "SUI_Party2")
    		Sui_PowerMath("party2", 136, 14, "SUI_Party2")
    	end
    end
    if (toon=="party3" or toon=="all") then
    	if task=="setup" then
    		PartyMemberFrame3:Hide()
			if ( not UnitExists("party3") ) then
				SUI_Party3:Hide()
			else
				SUI_Party3:Show()
							
				SUI_Party3_Name:SetText(UnitName("party3"))
				SUI_Party3_Level:SetText(UnitLevel("party3"))
				
				SetPortraitTexture(SUI_Party3_Portrait,"party3")			
				Sui_RaidIcon("party3", SUI_Party3_RaidIcon, 30)
				Sui_ClassIcon("party3", SUI_Party3_ClassIcon, 20)
    			Sui_HealthMath("party3", 120, 15, "SUI_Party3")
    			Sui_PowerMath("party3", 136, 14, "SUI_Party3")
    		end
    		if suiData.partyToggle=="off" then
    			SUI_Party3:Hide()
    		end
    	elseif task=="update" then
    		Sui_HealthMath("party3", 120, 15, "SUI_Party3")
    		Sui_PowerMath("party3", 136, 14, "SUI_Party3")
    	end
    end
    if (toon=="party4" or toon=="all") then
    	if task=="setup" then
    		PartyMemberFrame4:Hide()
			if (not UnitExists("party4")) then
				SUI_Party4:Hide()
			else
				SUI_Party4:Show()
							
				SUI_Party4_Name:SetText(UnitName("party4"))
				SUI_Party4_Level:SetText(UnitLevel("party4"))
				
				SetPortraitTexture(SUI_Party4_Portrait,"party4")			
				Sui_RaidIcon("party4", SUI_Party4_RaidIcon, 30)
				Sui_ClassIcon("party4", SUI_Party4_ClassIcon, 20)
    			Sui_HealthMath("party4", 120, 15, "SUI_Party4")
    			Sui_PowerMath("party4", 136, 14, "SUI_Party4")
    		end
    		if suiData.partyToggle=="off" then
    			SUI_Party4:Hide()
    		end
    	elseif task=="update" then
    		Sui_HealthMath("party4", 120, 15, "SUI_Party4")
    		Sui_PowerMath("party4", 136, 14, "SUI_Party4")
    	end
    end
end


function Sui_GetSpec(toon, inspected)
	if not inspected then
		if UnitExists("target") then
			SUI_MouseTooltip_Text:SetText("Not available.")
			if CheckInteractDistance("target", 1)==1 and not UnitIsUnit("target", "player") then
				NotifyInspect("target")
			else
				local englishFaction1, localizedFaction = UnitFactionGroup("target")
				local englishFaction2, localizedFaction = UnitFactionGroup("player")
				local _, instanceType = IsInInstance()
				if englishFaction1==englishFaction2 and UnitPlayerControlled("target") and not UnitIsUnit("target", "pet") and not (instanceType=="pvp") then
					SendAddonMessage("SUI", "find "..UnitName("player").." spec".." ".."current", "WHISPER", UnitName("target"))
				end
			end
		end
	elseif inspected then
		local value = Sui_FindSpecInfo("target")
		-- if value then
			Sui_DeliverSpecInfo(value)
		-- end
	end
end

function Sui_FindSpecInfo(toon, caller)
	if toon=="target" then
		inspect = 1
	else
		inspect = false
	end
	local t1Name, t1IconTexture, t1 = GetTalentTabInfo(1, inspect)
	local t2Name, t2IconTexture, t2 = GetTalentTabInfo(2, inspect)
	local t3Name, t3IconTexture, t3 = GetTalentTabInfo(3, inspect)
	local localizedClass, englishClass = UnitClass(toon)
	local content
	if not t3IconTexture then
		content="Not available"
	else
		content = (t1.."|"..t2.."|"..t3.."|"..(englishClass or "Unknown").."|"..t1IconTexture.."|"..t2IconTexture.."|"..t3IconTexture)
	end
	
	if caller then
		SendAddonMessage("SUI", "deliver "..toon.." spec "..content, "WHISPER", caller)
	else
		return content
	end
end

function Sui_DeliverSpecInfo(value)
	local t1, t2, t3, englishClass, t1IconTexture, t2IconTexture, t3IconTexture = strsplit("|", value)
	
	t1 = tonumber(t1)
	t2 = tonumber(t2)
	t3 = tonumber(t3)
	
	if ((t1 > t2) and (t1 > t3)) then
		spec = 2
	elseif (t2 > t3) then
		spec = 3
	else
		spec = 4
	end
	
	local text = "|cffffc100"..(SUI_Lang[englishClass][spec] or "error").." "
	text = text..(SUI_Lang[englishClass][1] or "error").."|r\r\n\r\n|T"
	text = text..(t1IconTexture or "error")..":16:16:0:0|t "
	text = text..(SUI_Lang[englishClass][2] or "error")..": "
	text = text..(t1 or "error").."\r\n|T"
	text = text..(t2IconTexture or "error")..":16:16:0:0|t "
	text = text..(SUI_Lang[englishClass][3] or "error")..": "
	text = text..(t2 or "error").."\r\n|T"
	text = text..(t3IconTexture or "error")..":16:16:0:0|t "
	text = text..(SUI_Lang[englishClass][4] or "error")..": "
	text = text..(t3 or "error")
	SUI_MouseTooltip_Text:SetText(text)
end

--|  Self Icon Logic  |--

function Sui_Unit_Update()
	if ( UnitExists("player") ) then
		
		Sui_Unit_UpdateLootMethod()
		Sui_Unit_UpdatePvPStatus()
	end
	Sui_Unit_UpdatePartyLeader()
	Sui_Unit_UpdateStatus()
	Sui_Unit_UpdateAFK()
end

function Sui_UpdateComboPoints()
	local points = GetComboPoints()
	local _, englishClass = UnitClass("player")
	if englishClass~="WARRIOR" then
		ComboFrame:SetAlpha(0)
		ComboFrame:Hide()
		if points==0 then
			SUI_Target_Combo1:Hide()
			SUI_Target_Combo2:Hide()
			SUI_Target_Combo3:Hide()
			SUI_Target_Combo4:Hide()
			SUI_Target_Combo5:Hide()
		elseif points==1 then
			SUI_Target_Combo1:Show()
			SUI_Target_Combo2:Hide()
			SUI_Target_Combo3:Hide()
			SUI_Target_Combo4:Hide()
			SUI_Target_Combo5:Hide()
		elseif points==2 then
			SUI_Target_Combo1:Show()
			SUI_Target_Combo2:Show()
			SUI_Target_Combo3:Hide()
			SUI_Target_Combo4:Hide()
			SUI_Target_Combo5:Hide()
		elseif points==3 then
			SUI_Target_Combo1:Show()
			SUI_Target_Combo2:Show()
			SUI_Target_Combo3:Show()
			SUI_Target_Combo4:Hide()
			SUI_Target_Combo5:Hide()
		elseif points==4 then
			SUI_Target_Combo1:Show()
			SUI_Target_Combo2:Show()
			SUI_Target_Combo3:Show()
			SUI_Target_Combo4:Show()
			SUI_Target_Combo5:Hide()
		elseif points==5 then
			SUI_Target_Combo1:Show()
			SUI_Target_Combo2:Show()
			SUI_Target_Combo3:Show()
			SUI_Target_Combo4:Show()
			SUI_Target_Combo5:Show()
		end
	end
end


-----------------------------------------------------------------------------------------------
--|  Purpose:	Declare which units need buff updates and how to find them                  |--
--|  Arguments:	toon = "player", "party1", etc...											|--

function Sui_UpdateBuffs(toon)
	local right = "right"
	local left = "left"
	if toon=="player" then
		Sui_BuffSubroutine("player", "SUI_Self", left)
	elseif toon=="target" then
		Sui_BuffSubroutine("target", "SUI_Target", right, false)
	elseif toon=="pet" then
		Sui_BuffSubroutine("pet", "SUI_Pet", right, true)
	elseif toon=="focus" then
		Sui_BuffSubroutine("focus", "SUI_Focus", left)
	elseif toon=="party1" then
		Sui_BuffSubroutine("party1", "SUI_Party1", right, true)
	elseif toon=="party2" then
		Sui_BuffSubroutine("party2", "SUI_Party2", right, true)
	elseif toon=="party3" then
		Sui_BuffSubroutine("party3", "SUI_Party3", right, true)
	elseif toon=="party4" then
		Sui_BuffSubroutine("party4", "SUI_Party4", right, true)
	elseif toon=="targettarget" then
		Sui_BuffSubroutine("targettarget", "SUI_TOT", left, true)
	end
end


-----------------------------------------------------------------------------------------------
--|  Purpose:	Creates & sets textures, buff count, tooltip IDs, location of buffs/debuffs |--
--|  Arguments:	toon = "player", "party1", etc...											|--
--|				prefix = unit frame string													|--
--|				direction = string.  "left" or "right" (determines tooltip dirction)		|--
--|				castable = true or false.  Whether the player can cast/dispel the spell		|--


function Sui_BuffSubroutine(toon, prefix, direction, castable)
	if (UnitBuff("player", 1) or UnitDebuff("player", 1)) then
		SUI_Pet:SetPoint("BOTTOMRIGHT", "SUI_HUD", "BOTTOM", -18, 237)
		SUI_Self_BuffBG:Show()
		-- DEFAULT_CHAT_FRAME:AddMessage("Pet Moved Up.  SelfShown, ", 0.5, 0.5, 0.5)
	else
		SUI_Pet:SetPoint("BOTTOMRIGHT", "SUI_HUD", "BOTTOM", -17, 215)
		SUI_Self_BuffBG:Hide()
		-- DEFAULT_CHAT_FRAME:AddMessage("Pet Moved Down. SelfHidden", 0.5, 0.5, 0.5)
	end
	

	if (UnitBuff("target", 1) or UnitDebuff("target", 1)) then
		SUI_Focus:SetPoint("BOTTOMLEFT", "SUI_HUD", "BOTTOM", 18, 237)
		SUI_Target_BuffBG:Show()
		-- DEFAULT_CHAT_FRAME:AddMessage("Focus Moved Up. TargetShown", 0.5, 0.5, 0.5)
	else
		SUI_Focus:SetPoint("BOTTOMLEFT", "SUI_HUD", "BOTTOM", 17, 215)
		SUI_Target_BuffBG:Hide()
		-- DEFAULT_CHAT_FRAME:AddMessage("Focus Moved Down. TargetHidden", 0.5, 0.5, 0.5)
	end
	
	local buffIndex = 1
	while buffIndex do	
		-- Initialize locals
		local name, rank, iconTexture, counter, duration, timeLeft, debuffType, buffLimit, debuffLimit
		local more = false
		local father_string = prefix.."_Buff"..buffIndex
		local icon_string = father_string.."_Icon"
		local count_string = father_string.."_Count"
		local unit = _G[prefix]
		
		-- Test Unit
		if toon=="player" then
			if not unit.buffLimit then
				unit.buffLimit = 9
				unit.debuffLimit = 3
			end
		end
		
		if toon=="target" then
			unit.buffLimit = 3
			unit.debuffLimit = 9
		end
		
		if toon~="target" and toon~="player" then
			if not unit.buffLimit then
				unit.buffLimit = 3
				unit.debuffLimit = 3
			end
			castable=true
		end
		
		buffLimit = unit.buffLimit
		debuffLimit = unit.debuffLimit
		
		local debuffIndex = buffIndex-buffLimit
		
		-- Test for Buffs/Debuffs
		-- Create frame, texture, fontstring and set scripts if found
		if toon=="player" then
			hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges = GetWeaponEnchantInfo()
			if GetPlayerBuff(buffIndex, "HELPFUL|PASSIVE") and buffIndex<=buffLimit then
				Sui_BuffCreateFrames(father_string, icon_string, count_string, buffIndex, prefix, direction, toon)
			elseif GetPlayerBuff(buffIndex, "HARMFUL") and debuffIndex<=debuffLimit then
				Sui_BuffCreateFrames(father_string, icon_string, count_string, buffIndex, prefix, direction, toon)
			end
		else
			if UnitBuff(toon, buffIndex, castable) and buffIndex<=buffLimit then
				Sui_BuffCreateFrames(father_string, icon_string, count_string, buffIndex, prefix, direction, toon)
				_G[father_string].castable = castable
			elseif UnitDebuff(toon, debuffIndex) and debuffIndex<=debuffLimit then
				Sui_BuffCreateFrames(father_string, icon_string, count_string, buffIndex, prefix, direction, toon)
				_G[father_string].castable = castable
			end
		end
		
		local father, icon, count = _G[father_string], _G[icon_string], _G[count_string]
		--SUI_MouseTooltip_Text:SetText("father: "..(father_string or "none").."\ricon: "..(icon_string or "none").."\rcount: "..(count_string or "none"))
		--SUI_MouseTooltip:Show()
		
		-- Populate and add reference stubs (type, ID)
		if father and toon=="player" then
			if buffIndex<=buffLimit then
				local buffID = GetPlayerBuff(buffIndex, "HELPFUL|PASSIVE")
				iconTexture = GetPlayerBuffTexture(buffID)
				counter = GetPlayerBuffApplications(buffID)
				father.buffID = buffID
				father.type = "buff"
			elseif debuffIndex<=debuffLimit then
				local debuffID = GetPlayerBuff(debuffIndex, "HARMFUL")
				iconTexture = GetPlayerBuffTexture(debuffID)
				counter = GetPlayerBuffApplications(debuffID)
				father.buffID = debuffID
				father.type = "debuff"
			end
			
			if (buffIndex+1)<=buffLimit and GetPlayerBuff(buffIndex+1, "HELPFUL|PASSIVE") then
				more = true
			elseif more==false then
				if (debuffIndex+1)<=debuffLimit and GetPlayerBuff(debuffIndex+1, "HARMFUL") then
					more = true
				end
			end
			
		elseif father then
			if buffIndex<=buffLimit then
				_, _, iconTexture, counter, _, _ =  UnitBuff(toon, buffIndex, castable)
				father.buffID = buffIndex
				father.type = "buff"
			elseif debuffIndex<=debuffLimit then
				_, _, iconTexture, counter, _, _, _  =  UnitDebuff(toon, debuffIndex)
				father.debuffID = debuffIndex
				father.type = "debuff"
			end
			
			if (buffIndex+1)<=buffLimit and UnitBuff(toon, buffIndex+1, castable) then
				more = true
			elseif more==false then
				if (debuffIndex+1)<=debuffLimit and UnitDebuff(toon, debuffIndex+1) then
					more = true
				end
			end
		end
		
		if counter==0 or counter==1 then
			counter=""
		end
		
		if father then
			icon:SetTexture(iconTexture)
			count:SetText(counter)
			-- DEFAULT_CHAT_FRAME:AddMessage("father("..father_string..") set to "..(iconTexture or "none"), 0.5, 0.5, 0.5)
		end
		
		-- Determine if more buffs/debuffs exist and loop as necessary
		-- Hide/show next/previous frame as necessary
		if more then
			local recordedIndex = buffIndex
			while _G[prefix.."_Buff"..buffIndex+1] do
				_G[prefix.."_Buff"..buffIndex+1]:Show()
				buffIndex = buffIndex + 1
			end
			buffIndex = recordedIndex + 1
		else
			while _G[prefix.."_Buff"..buffIndex+1] do
				_G[prefix.."_Buff"..buffIndex+1]:Hide()
				buffIndex = buffIndex + 1
			end
			buffIndex = nil
		end
	end
end


function Sui_BuffCreateFrames(father_string, icon_string, count_string, buffIndex, prefix, direction, toon)
	if not _G[father_string] then
		father = CreateFrame("Button", father_string, _G[prefix.."Frame_Info"])
		
		-- Position the frame
		-- If any lower-numbered frame exists, attach to it instead
		if _G[prefix.."_Buff"..(buffIndex-1)] then
			if direction=="left" then
				father:SetPoint("BOTTOMRIGHT", _G[prefix.."_Buff"..(buffIndex-1)], "BOTTOMLEFT", -1, 0)
			elseif direction=="right" then
				father:SetPoint("BOTTOMLEFT", _G[prefix.."_Buff"..(buffIndex-1)], "BOTTOMRIGHT", 1, 0)
			end
		else
			local yOffset, xOffset = -4, 26
			
			if toon=="player" then
				yOffset = yOffset + 22
				xOffset = xOffset - 34
			elseif toon=="target" then
				yOffset = yOffset + 22
				xOffset = xOffset
			end
			
			if direction=="left" then
				father:SetPoint("TOPRIGHT", _G[prefix.."_Button"], "TOPRIGHT", -xOffset, yOffset)
			elseif direction=="right" then
				father:SetPoint("TOPLEFT", _G[prefix.."_Button"], "TOPLEFT", xOffset, yOffset)
			end
		end
		
		father:SetWidth(16)
		father:SetHeight(16)
		father:SetScript("OnEnter", Sui_BuffTooltip_Enter)
		father:SetScript("OnLeave", Sui_BuffTooltip_Leave)
		father:SetScript("OnClick", Sui_BuffTooltip_Click)
		father:RegisterForClicks("RightButtonDown")
		father:EnableMouse(true)
		
		icon = father:CreateTexture(icon_string,"HIGH")
		icon:SetTexCoord(0.0625,0.9375,0.0625,0.9375)
		icon:SetAllPoints(father)
		
		count = father:CreateFontString(count_string,"OVERLAY")
		count:SetPoint("BOTTOM", icon_string, "BOTTOM", 0, 0)
		count:SetFontObject(SUI_FontRoundedBlocks)
		count:SetJustifyH("CENTER")
	end
end


function Sui_BuffTooltip_Enter()
	local frame = EnumerateFrames()
	while frame do
    	if frame:IsVisible() and MouseIsOver(frame) then
    		local frame_string = frame:GetName()
    		local start, finish
    	    if type(frame_string)=="string" then
	    	   start, finish = string.find(frame_string, "_Buff", 1, true)
    	    end
    	    
    	    -- if a match is found, setup tooltip and show
    	    if start then
    	    	local father = _G[frame_string]
    	    	local castable = father.castable
    	    	local buffIndex, buffType
    	    	if father.buffID then
    	    		buffType = "buff"
    	    		buffIndex = father.buffID
    		    else
    	    		buffType = "debuff"
    	    		buffIndex = father.debuffID
    		    end
    		    
    		    local toon, direction = Sui_TestParent(string.sub(frame_string, 1, start-1))
    		    
    		    --SUI_TestString2:SetText("BuffIndex="..(buffIndex or "none").."\rFather="..(frame:GetName()).."\rdirection="..direction.."\rtype="..(father.type or "none"))
    		    --SUI_TestString2:SetJustifyH("LEFT")
    		    
    	    	GameTooltip:SetOwner(father, direction)
    	    	
				if toon=="player" then
					GameTooltip:SetPlayerBuff(buffIndex)
				else
					if father.type=="buff" then
						GameTooltip:SetUnitBuff(toon, buffIndex, castable)
					elseif father.type=="debuff" then
						GameTooltip:SetUnitDebuff(toon, buffIndex)
					end
				end
    	    	GameTooltip:Show()
    	    end
    	end
    	frame = EnumerateFrames(frame)
	end
end

function Sui_BuffTooltip_Leave()
	GameTooltip:Hide()
end

function Sui_BuffTooltip_Click()
	local frame = EnumerateFrames()
	while frame do
    	if frame:IsVisible() and MouseIsOver(frame) then
    		local frame_string = frame:GetName()
    	    local start, finish = string.find(frame_string, "_Buff", 1, true)
    	    if start then
    	    	local father = _G[frame_string]
    	    	CancelPlayerBuff(father.buffID)
    	    end
    	end
    	frame = EnumerateFrames(frame)
	end
end


function Sui_TestParent(stringName)
	local right = "ANCHOR_TOPRIGHT"
	local left = "ANCHOR_TOPLEFT"
	if stringName=="SUI_Self" then
		return "player", left
	elseif stringName=="SUI_Target" then
		return "target", right
	elseif stringName=="SUI_Pet" then
		return "pet", left
	elseif stringName=="SUI_Focus" then
		return "focus", right
	elseif stringName=="SUI_Party1" then
		return "party1", left
	elseif stringName=="SUI_Party2" then
		return "party2", left
	elseif stringName=="SUI_Party3" then
		return "party3", left
	elseif stringName=="SUI_Party4" then
		return "party4", left
	elseif stringName=="SUI_TOT" then
		return "targettarget", right
	end
end


-- $parent equivalent == this:GetParent():GetName()

--|  Leader Icon  |--

function Sui_Unit_UpdatePartyLeader()
	SUI_Self_LeaderIcon:Hide()
	SUI_Party1_LeaderIcon:Hide()
	SUI_Party2_LeaderIcon:Hide()
	SUI_Party3_LeaderIcon:Hide()
	SUI_Party4_LeaderIcon:Hide()
	SUI_Target_LeaderIcon:Hide()
	
	if UnitIsPartyLeader("player") then
		SUI_Self_LeaderIcon:Show()
	elseif UnitIsPartyLeader("party1") then
		SUI_Party1_LeaderIcon:Show()
	elseif UnitIsPartyLeader("party2") then
		SUI_Party2_LeaderIcon:Show()
	elseif UnitIsPartyLeader("party3") then
		SUI_Party3_LeaderIcon:Show()
	elseif UnitIsPartyLeader("party4") then
		SUI_Party4_LeaderIcon:Show()
	end
	if UnitIsPartyLeader("target") then
		SUI_Target_LeaderIcon:Show()
	end
end


--|  Master Looter Icon  |--

function Sui_Unit_UpdateLootMethod()
	local lootMethod, lootMaster = GetLootMethod()
	if ( lootMaster == 0 and ((GetNumPartyMembers() > 0) or (GetNumRaidMembers() > 0)) ) then
		SUI_Self_MasterIcon:Show()
	else
		SUI_Self_MasterIcon:Hide()
	end
end


--|  PvP Icon  |--

function Sui_Unit_UpdatePvPStatus()
	Sui_Unit_UpdatePVPSubtask("player", SUI_Self_PVPIcon)
	Sui_Unit_UpdatePVPSubtask("party1", SUI_Party1_PVPIcon)
	Sui_Unit_UpdatePVPSubtask("party2", SUI_Party2_PVPIcon)
	Sui_Unit_UpdatePVPSubtask("party3", SUI_Party3_PVPIcon)
	Sui_Unit_UpdatePVPSubtask("party4", SUI_Party4_PVPIcon)
	Sui_Unit_UpdatePVPSubtask("target", SUI_Target_PVPIcon)
end

function Sui_Unit_UpdatePVPSubtask(toon, texture)
	local factionGroup, factionName = UnitFactionGroup(toon)
	if ( UnitIsPVPFreeForAll(toon) ) then
		texture:SetTexture("Interface\\TargetingFrame\\UI-PVP-FFA")
		texture:Show()
	elseif ( factionGroup and UnitIsPVP(toon) ) then
		texture:SetTexture("Interface\\TargetingFrame\\UI-PVP-"..factionGroup)
		texture:Show()
	else
		texture:Hide()
	end
end


--|  Rest & Attack Icons  |--

function Sui_Unit_UpdateStatus_Subtask(toon, attackicon, resticon)
	if UnitExists(toon) then
		if IsResting() and toon=="player" then
			attackicon:Hide()
			resticon:Show()
		elseif (UnitAffectingCombat(toon)) then
			attackicon:Show()
			resticon:Hide()
		else
			attackicon:Hide()
			resticon:Hide()
		end
	end
end

function Sui_Unit_UpdateStatus()
	Sui_Unit_UpdateStatus_Subtask("player", SUI_Self_AttackIcon, SUI_Self_RestIcon)
	Sui_Unit_UpdateStatus_Subtask("party1", SUI_Party1_AttackIcon, SUI_Party1_RestIcon)
	Sui_Unit_UpdateStatus_Subtask("party2", SUI_Party2_AttackIcon, SUI_Party2_RestIcon)
	Sui_Unit_UpdateStatus_Subtask("party3", SUI_Party3_AttackIcon, SUI_Party3_RestIcon)
	Sui_Unit_UpdateStatus_Subtask("party4", SUI_Party4_AttackIcon, SUI_Party4_RestIcon)
	Sui_Unit_UpdateStatus_Subtask("target", SUI_Target_AttackIcon, SUI_Target_RestIcon)
end


--|  AFK icon  |--

function Sui_Unit_UpdateAFK_Subtask(toon, icon)
	if UnitIsAFK(toon) then
		icon:SetTexture("Interface\\AddOns\\SpartanUI\\Textures\\Icon_AFK.blp")
		icon:SetHeight(32)
		icon:Show()
	else
		icon:Hide()
		icon:SetHeight(64)
		icon:SetTexture("Interface\\AddOns\\SpartanUI\\Textures\\Icon_Readycheck_Maybe.blp")
	end
end

function Sui_Unit_UpdateAFK()
	Sui_Unit_UpdateAFK_Subtask("player", SUI_Self_ReadyMaybe)
	Sui_Unit_UpdateAFK_Subtask("target", SUI_Target_ReadyMaybe)
	Sui_Unit_UpdateAFK_Subtask("party1", SUI_Party1_ReadyMaybe)
	Sui_Unit_UpdateAFK_Subtask("party2", SUI_Party2_ReadyMaybe)
	Sui_Unit_UpdateAFK_Subtask("party3", SUI_Party3_ReadyMaybe)
	Sui_Unit_UpdateAFK_Subtask("party4", SUI_Party4_ReadyMaybe)
end
	


--|  Pet Happiness  |--

function Sui_Pet_UpdateHappiness()
	local happiness, damagePercentage, loyaltyRate = GetPetHappiness()
	local hasPetUI, isHunterPet = HasPetUI()
	if ( not happiness or not isHunterPet ) then
		SUI_Pet_HappinessIcon:Hide()
		return
	end
	SUI_Pet_HappinessIcon:Show()
	if ( happiness == 1 ) then
		SUI_Pet_HappinessIcon:SetTexCoord(0.375, 0.5625, 0, 0.359375)
	elseif ( happiness == 2 ) then
		SUI_Pet_HappinessIcon:SetTexCoord(0.1875, 0.375, 0, 0.359375)
	elseif ( happiness == 3 ) then
		SUI_Pet_HappinessIcon:SetTexCoord(0, 0.1875, 0, 0.359375)
	end
	-- PetFrameHappiness.tooltip = getglobal("PET_HAPPINESS"..happiness)
	-- PetFrameHappiness.tooltipDamage = format(PET_DAMAGE_PERCENTAGE, damagePercentage)
	if ( loyaltyRate < 0 ) then
		-- PetFrameHappiness.tooltipLoyalty = getglobal("LOSING_LOYALTY")
	elseif ( loyaltyRate > 0 ) then
		-- PetFrameHappiness.tooltipLoyalty = getglobal("GAINING_LOYALTY")
	else
		-- PetFrameHappiness.tooltipLoyalty = nil
	end
end


--|  SpinCam  |--

function Sui_SpinCam()
	local toggle = GetCVar("autoClearAFK")
	if toggle=="0" then
		return
	elseif toggle=="1" then
		if isSpinning==0 then
			SetCVar("cameraYawMoveSpeed","7.33")
			MoveViewRightStart()
			SetView(5)
		elseif isSpinning==1 then
			MoveViewRightStop()
			SetCVar("cameraYawMoveSpeed","230")
			SetView(5)
		end
	end
end


function Sui_MobTip()
	if IsAddOnLoaded("MobInfo2")==1 then
    	local mobData = MI2_GetMobData( UnitName("target"), UnitLevel("target"), "target" )
    	if mobData~=nil then
			local typeMob
			if mobData.mobType==3 then
				typeMob = " Boss "..UnitCreatureType("target")
			elseif mobData.mobType==2 then
				typeMob = " Elite "..UnitCreatureType("target")
			else
				typeMob = " Mob "..UnitCreatureType("target")
			end
			
    		local rtn = "\r"
			local text = "|cffffc100"..UnitName("target").."|r\r"..UnitLevel("target")..typeMob..rtn..rtn.."Health: "..(mobData.healthMax or "_")..rtn.."Mana: "..(UnitManaMax("target") or "_")..rtn.."Damage: "..(mobData.minDamage or "_").." - "..(mobData.maxDamage or "_")..rtn.."XP: "..(mobData.xp or "_")
			    	
			SUI_MouseTooltip_Text:SetText(text)    	
   		end
    end
    
    suiVerse = {}
    
end


--|  Boss Health Tracker  |--
function TrackHealthOff()
	if not Boss_LowestHealth or Boss_LowestHealth==0 then
		Boss_LowestHealth = (UnitHealth("focus") / UnitHealthMax("focus")) *100
	end
	local CurrentHealth = (UnitHealth("focus") / UnitHealthMax("focus")) * 100
	
	if CurrentHealth < Boss_LowestHealth then
		Boss_LowestHealth = CurrentHealth
	end
	
	SUI_TestString:SetText(Boss_LowestHealth)
	if BossLowestHealth==Dead then
		BossLowestHealth=0
		SUI_TestString:SetText("Focus has died!")
	end
end


function Sui_PFix()
	if IsAddOnLoaded("Adapt")==1 then
    	SUI_TOT_PortraitModelModel:SetFrameLevel(3)
    end
end

function Sui_FindEvents(arg1)
	local framename = getglobal(arg1)
	if framename then
		SUI_MouseTooltip_Text:SetText("|cffffc100"..arg1.." registered events: |r\r")
		Sui_Events = {}
		i = 0
		for v in pairs(DevTools_Events) do
			i = i + 1
			Sui_Events[i] = v
		end
		
		local t = Sui_Events
		table.sort(t, AlphabeticSort)
		for i,v in ipairs(t) do			
			local isRegistered = framename:IsEventRegistered(v)
			if isRegistered then
				local text = SUI_MouseTooltip_Text:GetText()
				local text = text..v.."\r"
				SUI_MouseTooltip_Text:SetText(text)
			end
		end
		
		SUI_MouseTooltip:Show()
	else
		DEFAULT_CHAT_FRAME:AddMessage(arg1.." could not be found or was not a frame.", 1, .2, 0.2)
	end
end

function Sui_FindChildren(arg1)
	local framename = getglobal(arg1)
	if framename then
		local text
		varDB, i = {framename:GetChildren()}, 1
		for k,v in pairs(varDB) do
			local q = v:GetName()
			text = (text or "|cffffc100List of Children:|r").."\r "..k..": "..(q or "")
		end
		SUI_MouseTooltip_Text:SetText(text)
		if SUI_MouseTooltip_Text:GetText()==nil then
			SUI_MouseTooltip_Text:SetText("No children found for ".. arg1)
		end
		SUI_MouseTooltip:Show()
	else
		DEFAULT_CHAT_FRAME:AddMessage(arg1.." could not be found or was not a frame.", 1, .2, 0.2)
	end
end

function AlphabeticSort(a, b)	
	return a<b
end

function Sui_Chatter(arg1)
	if arg1=="on" then
		ChatFrame1:RegisterEvent("CHAT_MSG_MONSTER_SAY")
		DEFAULT_CHAT_FRAME:AddMessage("SpartanUI: Chatter on", 0.5, 0.5, 0.5)
		suiData.chatter = false
	elseif arg1=="off" then
		ChatFrame1:UnregisterEvent("CHAT_MSG_MONSTER_SAY")
		DEFAULT_CHAT_FRAME:AddMessage("SpartanUI: Chatter off", 0.5, 0.5, 0.5)
		suiData.chatter = true
	end
end

function Sui_ResDetect()
	if not suiData.scale then
		local resolution =({GetScreenResolutions()})[GetCurrentResolution()];
		local x, y = strmatch(resolution, "(%d+)x(%d+)")
		local ratio = tonumber(x) / tonumber(y)
		if ratio < 1.4 then
			suiData.scale = .78
		else
			suiData.scale = .92
		end
		SpartanUI:SetScale(suiData.scale)
	else
		SpartanUI:SetScale(suiData.scale)
	end
end

function Sui_MessageFlasher(message, flash, fade)
	local f = CreateFrame("Frame", "SUI_MessageFlasher", UIParent)
	f:SetWidth(500)
	f:SetHeight(125)
	f:SetFrameStrata("HIGH")
	f:SetPoint("CENTER", UIParent, "CENTER", 0, 0)
	local t = f:CreateTexture(nil, "ARTWORK")
	t:SetTexture(0,0,0, 0.80)
	t:SetAllPoints(f)
	local s = f:CreateFontString("SUI_MessageFlasher_String","OVERLAY")
	s:SetPoint("CENTER", f, "CENTER")
	s:SetFontObject(SUI_FontTitle16)
	s:SetText(message)
	if flash then
		UIFrameFlash(f, 0.25, .25, -1, true, 0, 4)
	end
	if fade then
		UIFrameFlash(f, 0, 5, 10, false, 0, 5)
		-- UIFrameFlash(frame, fadeInTime, fadeOutTime, flashDuration, showWhenDone, flashInHoldTime, flashOutHoldTime)
	end
end

--|  Event Handling  |--

function Sui_OnEvent()
	if (event=="ADDON_LOADED") then
		if arg1=="Blizzard_BindingUI" then
			local style = SUI_Multilingual
			KeyBindingFrameBinding1Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding1Description:SetFontObject(style)
			KeyBindingFrameBinding2Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding2Description:SetFontObject(style)
			KeyBindingFrameBinding3Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding3Description:SetFontObject(style)
			KeyBindingFrameBinding4Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding4Description:SetFontObject(style)
			KeyBindingFrameBinding5Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding5Description:SetFontObject(style)
			KeyBindingFrameBinding6Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding6Description:SetFontObject(style)
			KeyBindingFrameBinding7Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding7Description:SetFontObject(style)
			KeyBindingFrameBinding8Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding8Description:SetFontObject(style)
			KeyBindingFrameBinding9Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding9Description:SetFontObject(style)
			KeyBindingFrameBinding10Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding10Description:SetFontObject(style)
			KeyBindingFrameBinding11Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding11Description:SetFontObject(style)
			KeyBindingFrameBinding12Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding12Description:SetFontObject(style)
			KeyBindingFrameBinding13Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding13Description:SetFontObject(style)
			KeyBindingFrameBinding14Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding14Description:SetFontObject(style)
			KeyBindingFrameBinding15Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding15Description:SetFontObject(style)
			KeyBindingFrameBinding16Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding16Description:SetFontObject(style)
			KeyBindingFrameBinding17Description:SetTextColor(1, .65, 0)
			KeyBindingFrameBinding17Description:SetFontObject(style)
		end
	elseif (event=="CHAT_MSG_SYSTEM") then
		if ( arg1 == "You are now AFK: Away from Keyboard" ) then
			isSpinning = 0
			Sui_SpinCam()
		elseif ( arg1 == "You are no longer AFK.") then
			isSpinning = 1
			Sui_SpinCam()
		end
	elseif (event=="CHAT_MSG_CHANNEL") then
		--i = 1
		--while (_G["arg"..i]) do
		--	DEFAULT_CHAT_FRAME:AddMessage("arg"..i.." = ".._G["arg"..i], 0.5, 0.5, 0.5)
		--	i = i + 1
		--end
	elseif (event=="CHAT_MSG_ADDON") then
		if arg1=="SUI" then
			local task, caller, subject, value = strsplit(" ", arg2)	-- parse the message into variables
			if task=="find" and subject=="spec" then
				Sui_FindSpecInfo(UnitName("player"), caller)
			elseif task=="deliver" and subject=="spec" then
				Sui_DeliverSpecInfo(value)
			elseif task=="find" and subject=="version" then
				SendAddonMessage("SUI", "deliver "..UnitName("player").." "..subject.." "..SUI_currentVersion, "WHISPER", caller)
			elseif task=="deliver" and subject=="version" then
				DEFAULT_CHAT_FRAME:AddMessage(caller ..": ".. value, 0.65, 0.65, 0.65)
			elseif task=="find" and subject=="performance" then
				local fps = math.floor(GetFramerate())
				local time = GetAddOnCPUUsage("SpartanUI")
				local down, up, lag = GetNetStats()
				SendAddonMessage("SUI", "deliver "..UnitName("player").." "..subject.." "..lag.."|"..fps.."|"..time, "WHISPER", caller)
			elseif task=="deliver" and subject=="performance" then
				local lag, fps, time = strsplit("|", value)
				DEFAULT_CHAT_FRAME:AddMessage(caller..": Latency="..lag..", FPS="..fps, 0.65, 0.65, 0.65)
			elseif task=="find" and subject=="petname" then
				SUI_Pet_Name:SetText(UnitName("pet"))
				if UnitName("pet")==UNKNOWNOBJECT then
					SendAddonMessage("SUI", "find "..UnitName("player").." petname".." ".."unknown", "WHISPER", UnitName("player"))
				end
			end
		end
	elseif (event=="CHAT_MSG_COMBAT_FACTION_CHANGE") then
		local reputation_, with_, f1_, f2_, f3_ = strsplit(" ", arg1)
		suiData.currentFaction = f1_
		if f2_~="increased" then
			suiData.currentFaction = suiData.currentFaction.." "..(f2_ or "unknown")
			if f3_~="increased" then
				suiData.currentFaction = suiData.currentFaction.." "..(f3_ or "unknown")
			end
		end
		if (GetWatchedFactionInfo())~=suiData.currentFaction then
			for factionIndex = 1, GetNumFactions() do
				local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, isWatched = GetFactionInfo(factionIndex)
				suiData.factionDescription = description
				suiData.factionIndex = factionIndex
				if name==(suiData.currentFaction or "none") then
					SetWatchedFactionIndex(factionIndex)
					Sui_RepBar()
				end
			end
		end
	elseif (event=="CHAT_MSG_COMBAT_XP_GAIN") then
		SUI_mobXP = string.match(arg1, "%d+")
		local a, b = string.find(arg1, " dies")
		local test = strsplit(" ", arg1)
		if test~="You" then
			SUI_mobLast = string.sub(arg1, 1, a-1)
		end
	elseif (event=="UNIT_AURA") then
		Sui_UpdateBuffs(arg1)
		if UnitExists("targettarget") then
			Sui_UpdateBuffs("targettarget")
		end
	elseif (event=="UNIT_HEALTH") then
    	Sui_SetupMembers(arg1, "update")
    	if UnitExists("targettarget") then
    		Sui_SetupMembers("targettarget", "update")
    	end
	elseif (event=="UNIT_LEVEL") then
		if arg1=="player" then
    		SUI_Self_Level:SetText(UnitLevel("player"))
    		SUI_XP_CurrentLevel:SetText("Level: "..UnitLevel("player"))
    	elseif arg1=="target" then
    		SUI_Target_Level:SetText(UnitLevel("target"))
    	elseif arg1=="party1" then
    		SUI_Party1_Level:SetText(UnitLevel("party1"))
    	elseif arg1=="party2" then
    		SUI_Party2_Level:SetText(UnitLevel("party2"))
    	elseif arg1=="party3" then
    		SUI_Party3_Level:SetText(UnitLevel("party3"))
    	elseif arg1=="party4" then
    		SUI_Party4_Level:SetText(UnitLevel("party4"))
    	elseif arg1=="pet" then
    		SUI_Pet_Level:SetText(UnitLevel("pet"))
    	end
	elseif (event=="UNIT_MANA") then
		Sui_SetupMembers(arg1, "update")
		if UnitExists("targettarget") then
    		Sui_SetupMembers("targettarget", "update")
    	end
   	elseif (event=="UNIT_RAGE") then
		Sui_SetupMembers(arg1, "update")
		if UnitExists("targettarget") then
    		Sui_SetupMembers("targettarget", "update")
    	end
	elseif (event=="UNIT_ENERGY") then
		Sui_SetupMembers(arg1, "update")
		if UnitExists("targettarget") then
    		Sui_SetupMembers("targettarget", "update")
    	end
    elseif (event=="UNIT_FOCUS") then
    	Sui_SetupMembers("pet", "update")
    	if UnitIsUnit("target", "pet") then
    		Sui_SetupMembers("target", "update")
    	end
    	if UnitIsUnit("targettarget", "pet") then
    		Sui_SetupMembers("targettarget", "update")
    	end
    elseif (event=="UNIT_PET") then
    	Sui_SetupMembers("pet", "setup")
	elseif (event=="UNIT_PORTRAIT_UPDATE") then
		if arg1=="player" then
			SetPortraitTexture(SUI_Self_Portrait,arg1)
			SetPortraitTexture(SUI_XP_Portrait,arg1)
		elseif arg1=="pet" then
			SetPortraitTexture(SUI_Pet_Portrait,arg1)
		elseif arg1=="focus" then
			SetPortraitTexture(SUI_Focus_Portrait,arg1)
		elseif arg1=="target" then
			SetPortraitTexture(SUI_Target_Portrait,arg1)
		elseif arg1=="party1" then
			SetPortraitTexture(SUI_Party1_Portrait,arg1)
		elseif arg1=="party2" then
			SetPortraitTexture(SUI_Party2_Portrait,arg1)
		elseif arg1=="party3" then
			SetPortraitTexture(SUI_Party3_Portrait,arg1)
		elseif arg1=="party4" then
			SetPortraitTexture(SUI_Party4_Portrait,arg1)
		end
		if UnitExists("targettarget") then
    		SetPortraitTexture(SUI_TOT_Portrait,"targettarget")
    	end
	elseif (event=="UPDATE_FACTION") then
		Sui_RepBar()
		if BT3BarREPUTATION then
			if BT3BarREPUTATION:IsVisible() then
				BT3BarREPUTATION:Hide()
			end
		end
	elseif ( event == "UNIT_FACTION" ) then
		if ( arg1 == "player" ) then
			Sui_Unit_Update(arg1)
		end
	elseif ( event == "UNIT_HAPPINESS" ) then
		Sui_Pet_UpdateHappiness()
	elseif (event=="PLAYER_AURAS_CHANGED") then
		Sui_UpdateBuffs("player")
	elseif (event=="PLAYER_XP_UPDATE") then
		Sui_XPBar()
	elseif (event=="PLAYER_FOCUS_CHANGED") then
		Sui_SetupMembers("focus", "setup")
	elseif ( event == "PLAYER_ENTER_COMBAT" ) then
		SUI_ReadyCheckTimer = 60
		Sui_Unit_Update()
	elseif ( event == "PLAYER_LEAVE_COMBAT" ) then
		Sui_Unit_Update()
	elseif ( event == "PLAYER_REGEN_DISABLED" ) then
		SUI_ReadyCheckTimer = 60
		Sui_Unit_Update()
	elseif ( event == "PLAYER_REGEN_ENABLED" ) then
		Sui_Unit_Update()
	elseif ( event == "PLAYER_UPDATE_RESTING" ) then
		Sui_Unit_Update()
	elseif ( event=="PLAYER_LEAVING_WORLD" ) then
		SetCVar("cameraYawMoveSpeed","230")
		MoveViewRightStop()
	elseif(event=="PLAYER_ENTERING_WORLD") then
		Sui_Bartender()
		Sui_SetupMembers("all", "setup")
		Sui_XPBar()
		Sui_Unit_Update()
		MultiBarBottomLeft:Hide()
		MultiBarBottomRight:Hide()
		MultiBarLeft:Hide()
		MultiBarRight:Hide()
		local inInstance, instanceType = IsInInstance()
		if inInstance==1 then
			SUI_MinimapCoords:Hide()
		elseif not inInstance then
			SUI_MinimapCoords:Show()
    		SetMapToCurrentZone()
    	end
    	FramerateLabel:ClearAllPoints()
		FramerateLabel:SetPoint("CENTER", "WorldFrame", "BOTTOM", -15, 125)
		FramerateLabel:SetFontObject(SUI_FontLevel)
		FramerateText:SetFontObject(SUI_FontLevel)
    	Sui_BarFix()
    	PartyMemberBackground:SetAlpha(0)
		PartyMemberBackground:Hide()
		Sui_Unit_UpdateAFK_Subtask("player", SUI_Self_ReadyMaybe)
		
		-- Fix for CT_BarMod
		if IsAddOnLoaded("CT_BarMod")==1 then
			local i = 1
			while i <= 120 do
				local frame = _G["CT_BarModActionButton"..i]
				if frame then
					frame:Hide()
				end
				i = i + 1
			end
			Sui_MessageFlasher("CT_BarMod cannot be used with SpartanUI.", false, true)
		end
		
		-- Fix for Titan
		if IsAddOnLoaded("Titan")==1 then
			local unitServer = UnitName("player").."@"..GetRealmName()
			if TitanSettings.Players then
				TitanSettings.Players[unitServer].Panel.MinimapAdjust = 1
			else
				Sui_MessageFlasher("Please reload or relog to fix the minimap icons.", true)			
			end
		end
		
	elseif ( event=="PLAYER_ALIVE" ) then
		
	elseif ( event=="PLAYER_DEAD" ) then
		if godmode==1 then
			DEFAULT_CHAT_FRAME:AddMessage("Gee, I guess that feature isn't working yet. :(", 0.5, 0.5, 0.5)
			DEFAULT_CHAT_FRAME:AddMessage("Exiting God Mode.", 1, 0, 0)
			godmode=0
		end
	elseif ( event=="PLAYER_TARGET_CHANGED") then
		SUI_MouseTooltip_Text:SetText("Not available.")
		if not InCombatLockdown() then
			TargetFrame:Hide()
		end
		Sui_SetupMembers("target", "setup")
		if UnitExists("targettarget") then
			Sui_SetupMembers("targettarget", "setup")
			Sui_UpdateBuffs("targettarget")
    	else
    		SUI_TOT:Hide()
		end
		Sui_Unit_Update()
		Sui_UpdateBuffs("target")
		Sui_UpdateComboPoints()
		if UnitCastingInfo("target") then
			_G["target".."_isCasting"]=1
			Sui_CastMath("target", arg2, arg3, 148, 16, SUI_Target_CastBar)
		end
		if UnitChannelInfo("target") then
			_G["target".."_isChanneling"]=1
			Sui_CastMath("target", arg2, arg3, 148, 16, SUI_Target_CastBar)
		end
		
		
		if not UnitIsPlayer("target") then
			Sui_MobTip()
		end
	elseif (event=="PLAYER_COMBO_POINTS") then
		Sui_UpdateComboPoints()
	elseif (event=="PLAYER_FLAGS_CHANGED") then
		if arg1=="player" then
			Sui_Unit_UpdateAFK_Subtask("player", SUI_Self_ReadyMaybe)
		elseif arg1=="party1" then
			Sui_Unit_UpdateAFK_Subtask("party1", SUI_Party1_ReadyMaybe)
		elseif arg1=="party2" then
			Sui_Unit_UpdateAFK_Subtask("party2", SUI_Party2_ReadyMaybe)
		elseif arg1=="party3" then
			Sui_Unit_UpdateAFK_Subtask("party3", SUI_Party3_ReadyMaybe)
		elseif arg1=="party4" then
			Sui_Unit_UpdateAFK_Subtask("party4", SUI_Party4_ReadyMaybe)
		elseif arg1=="target" then
			Sui_Unit_UpdateAFK_Subtask("target", SUI_Target_ReadyMaybe)
		end
	elseif ( event == "PARTY_MEMBERS_CHANGED" or event == "PARTY_LEADER_CHANGED" or event == "RAID_ROSTER_UPDATE" ) then
		Sui_Unit_Update()
		Sui_SetupMembers("all", "setup")
		if not UnitExists("target") then
			SUI_TargetFrame:Hide()
		end
		PartyMemberBackground:SetAlpha(0)
		PartyMemberBackground:Hide()
	elseif ( event == "PARTY_LOOT_METHOD_CHANGED" ) then
		Sui_Unit_Update()
	elseif ( event == "QUEST_LOG_UPDATE") then
		QuestWatchFrame:ClearAllPoints()
		QuestWatchFrame:SetPoint("BOTTOMRIGHT", "UIParent", "BOTTOMRIGHT", -20, 200)
		QuestTimerFrame:ClearAllPoints()
		QuestTimerFrame:SetPoint("BOTTOM", "UIParent", "BOTTOM", 0, 250)
		DurabilityFrame:ClearAllPoints()
		DurabilityFrame:SetPoint("BOTTOM", "SUI_MapOverlay", "TOP", 0, 0)
	elseif (event=="TIME_PLAYED_MSG") then
		if not suiData.xpSetup then
			suiData.totalTime, suiData.currentTime = arg1, arg2
			ChatFrame1:RegisterEvent("TIME_PLAYED_MSG")
			suiData.xpSetup = true
			Sui_XPBar()
		end
	elseif ( event == "UPDATE_SHAPESHIFT_FORMS" ) then
		Sui_BarFix()
	elseif ( event == "UNIT_SPELLCAST_START") then
		if CastingBarFrame:IsVisible() then
			CastingBarFrame:Hide()
		end
		if Sui_ArgTest(arg1) then
			_G[arg1.."_isCasting"]=1
			if arg1=="player" then
				Sui_CastMath(arg1, arg2, arg3, 148, 16, SUI_Self_CastBar)
			elseif arg1=="focus" then
				Sui_CastMath(arg1, arg2, arg3, 130, 13, SUI_Focus_CastBar)
			elseif arg1=="target" then
				Sui_CastMath(arg1, arg2, arg3, 148, 16, SUI_Target_CastBar)
			elseif arg1=="party1" then
				Sui_CastMath(arg1, arg2, arg3, 120, 14, SUI_Party1_CastBar)
			elseif arg1=="party2" then
				Sui_CastMath(arg1, arg2, arg3, 120, 14, SUI_Party2_CastBar)
			elseif arg1=="party3" then
				Sui_CastMath(arg1, arg2, arg3, 120, 14, SUI_Party3_CastBar)
			elseif arg1=="party4" then
				Sui_CastMath(arg1, arg2, arg3, 120, 14, SUI_Party4_CastBar)
			end
		end
	
	elseif ( event == "UNIT_SPELLCAST_STOP") then
		if Sui_ArgTest(arg1) then
			_G[arg1.."_isCasting"]=0
			if arg1=="player" then
				Sui_CastMath(arg1, arg2, arg3, 148, 16, SUI_Self_CastBar)
			elseif arg1=="focus" then
				Sui_CastMath(arg1, arg2, arg3, 130, 13, SUI_Focus_CastBar)
			elseif arg1=="target" then
				Sui_CastMath(arg1, arg2, arg3, 148, 16, SUI_Target_CastBar)
			elseif arg1=="party1" then
				Sui_CastMath(arg1, arg2, arg3, 148, 16, SUI_Party1_CastBar)
			elseif arg1=="party2" then
				Sui_CastMath(arg1, arg2, arg3, 120, 14, SUI_Party2_CastBar)
			elseif arg1=="party3" then
				Sui_CastMath(arg1, arg2, arg3, 120, 14, SUI_Party3_CastBar)
			elseif arg1=="party4" then
				Sui_CastMath(arg1, arg2, arg3, 120, 14, SUI_Party4_CastBar)
			end
		end	
	
	elseif ( event == "UNIT_SPELLCAST_CHANNEL_START") then
		CastingBarFrame:Hide()
		if Sui_ArgTest(arg1) then
			_G[arg1.."_isChanneling"]=1
			if arg1=="player" then
				Sui_CastMath(arg1, arg2, arg3, 148, 16, SUI_Self_CastBar)
			elseif arg1=="focus" then
				Sui_CastMath(arg1, arg2, arg3, 130, 13, SUI_Focus_CastBar)
			elseif arg1=="target" then
				Sui_CastMath(arg1, arg2, arg3, 148, 16, SUI_Target_CastBar)
			elseif arg1=="party1" then
				Sui_CastMath(arg1, arg2, arg3, 148, 16, SUI_Party1_CastBar)
			elseif arg1=="party2" then
				Sui_CastMath(arg1, arg2, arg3, 120, 14, SUI_Party2_CastBar)
			elseif arg1=="party3" then
				Sui_CastMath(arg1, arg2, arg3, 120, 14, SUI_Party3_CastBar)
			elseif arg1=="party4" then
				Sui_CastMath(arg1, arg2, arg3, 120, 14, SUI_Party4_CastBar)
			end
		end
		
	elseif ( event == "UNIT_SPELLCAST_CHANNEL_STOP") then
		if Sui_ArgTest(arg1) then
			_G[arg1.."_isChanneling"]=0
			if arg1=="player" then
				Sui_CastMath(arg1, arg2, arg3, 148, 16, SUI_Self_CastBar)
			elseif arg1=="focus" then
				Sui_CastMath(arg1, arg2, arg3, 130, 13, SUI_Focus_CastBar)
			elseif arg1=="target" then
				Sui_CastMath(arg1, arg2, arg3, 148, 16, SUI_Target_CastBar)
			elseif arg1=="party1" then
				Sui_CastMath(arg1, arg2, arg3, 148, 16, SUI_Party1_CastBar)
			elseif arg1=="party2" then
				Sui_CastMath(arg1, arg2, arg3, 120, 14, SUI_Party2_CastBar)
			elseif arg1=="party3" then
				Sui_CastMath(arg1, arg2, arg3, 120, 14, SUI_Party3_CastBar)
			elseif arg1=="party4" then
				Sui_CastMath(arg1, arg2, arg3, 120, 14, SUI_Party4_CastBar)
			end
		end
		
	elseif ( event == "UNIT_SPELLCAST_INTERRUPTED") then						-- spell failed
	elseif ( event == "UNIT_SPELLCAST_FAILED") then								-- spell not ready
	elseif ( event == "UNIT_SPELLCAST_DELAYED") then							-- a real interruption (but for casts only)
		if Sui_ArgTest(arg1) then
			local spellName, _, _, _, startTime, endTime, other = UnitCastingInfo(arg1)
			if not endTime then
				return
			else
				_G[arg1.."SpellEnd"] = endTime/1000
			end
		end
	elseif ( event == "UNIT_SPELLCAST_CHANNEL_UPDATE") then 					-- a real interruption (but for channel only)
		if Sui_ArgTest(arg1) then
			local spellName, _, _, _, startTime, endTime, other = UnitChannelInfo(arg1)
			_G[arg1.."SpellEnd"] = endTime/1000
		end
	elseif ( event == "INSPECT_TALENT_READY" ) then
		Sui_GetSpec("target", true)
	elseif ( event == "VARIABLES_LOADED" ) then
		if FEDB.animateGrainCrispy then
			FG_OnEvent("film", "crisp")
		end
		if FEDB.animateGrainFuzzy then
			FG_OnEvent("film", "blur")
		end
		if FEDB.vignette then
			FG_OnEvent("vignette")
		end
		
		-- conditional registrations
		if not suiData.buffToggle or suiData.buffToggle=="on" then
			this:RegisterEvent("UNIT_AURA")
			this:RegisterEvent("PLAYER_AURAS_CHANGED")
		end
		Sui_MinimapFix()
		if not suiData.version or (suiData.version < SUI_currentVersion) then
			suiData.version = SUI_currentVersion
			suiData.layout = "Standard"
			-- DEFAULT_CHAT_FRAME:AddMessage("New version FirstLoad", 0.65, 0.65, 0.65)
		end
		Sui_InitializeLanguages()
		if suiData.chatter==false then
			Sui_Chatter("on")
		elseif suiData.chatter=="true" then
			Sui_Chatter("off")
		end
		Sui_ResDetect()
		suiData.partyToggle = (suiData.partyToggle or "on")
	elseif ( event == "VOICE_START") then
		if arg1=="player" then
			SUI_Self_VoiceIcon:Show()
		elseif arg1=="party1" then
			SUI_Party1_VoiceIcon:Show()
		elseif arg1=="party2" then
			SUI_Party2_VoiceIcon:Show()
		elseif arg1=="party3" then
			SUI_Party3_VoiceIcon:Show()
		elseif arg1=="party4" then
			SUI_Party4_VoiceIcon:Show()
		elseif arg1=="target" then
			SUI_Target_VoiceIcon:Show()
		end
		
	elseif ( event == "VOICE_STOP" ) then
		if arg1=="player" then
			SUI_Self_VoiceIcon:Hide()
		elseif arg1=="party1" then
			SUI_Party1_VoiceIcon:Hide()
		elseif arg1=="party2" then
			SUI_Party2_VoiceIcon:Hide()
		elseif arg1=="party3" then
			SUI_Party3_VoiceIcon:Hide()
		elseif arg1=="party4" then
			SUI_Party4_VoiceIcon:Hide()
		elseif arg1=="target" then
			SUI_Target_VoiceIcon:Hide()
		end
	elseif ( event == "READY_CHECK" ) then
		SUI_Self_ReadyMaybe:Show()
	elseif ( event == "READY_CHECK_CONFIRM" ) then
		if arg1==1 then
			if arg2==1 then
				SUI_Self_ReadyYes:Show()
				SUI_Self_ReadyMaybe:Hide()
			elseif arg2==0 then
				SUI_Self_ReadyNo:Show()
				SUI_Self_ReadyMaybe:Hide()
			end
		end
	elseif ( event == "READY_CHECK_FINISHED" ) then
		SUI_ReadyCheckTimer = 0
	elseif ( event == "RAID_TARGET_UPDATE" ) then
		Sui_RaidIcon("player", SUI_Self_RaidIcon, 40)
		Sui_RaidIcon("target", SUI_Target_RaidIcon, 40)
		Sui_RaidIcon("party1", SUI_Party1_RaidIcon, 30)
		Sui_RaidIcon("party2", SUI_Party2_RaidIcon, 30)
		Sui_RaidIcon("party3", SUI_Party3_RaidIcon, 30)
		Sui_RaidIcon("party4", SUI_Party4_RaidIcon, 30)
		Sui_RaidIcon("pet", SUI_Pet_RaidIcon, 30)
		Sui_RaidIcon("focus", SUI_Focus_RaidIcon, 30)
		Sui_RaidIcon("targettarget", SUI_TOT_RaidIcon, 30)
		-- Sui_RaidIcon("targettargettarget", SUI_TOTT_RaidIcon, 30)
	elseif ( event == "ZONE_CHANGED" ) then
		local inInstance, instanceType = IsInInstance()
		if inInstance==1 then
			SUI_MinimapCoords:Hide()
		elseif not inInstance then
			SUI_MinimapCoords:Show()
    		SetMapToCurrentZone()
    	end	
	end
end

function Sui_ArgTest(arg1)
	if (arg1=="player" or arg1=="party1" or arg1=="party2" or arg1=="party3" or arg1=="party4" or arg1=="target" or arg1=="targettarget" or arg1=="targettargettarget" or arg1=="focus") then
		return true
	else
		return nil
	end
end

function Sui_PanelOffset(frame)
	if frame=="reset" then
		local _, _, _, _, yOfs = SpartanUI:GetPoint(3)
		if yOfs~=0 then
			SpartanUI:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 0, 0)
			SpartanUI:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", 0, 0)
		end
	elseif frame:GetPoint()=="BOTTOMLEFT" and frame:IsVisible() then
		local _, _, _, _, yOfs = SpartanUI:GetPoint(3)
		local height = frame:GetHeight()
		if FuBarFrame2 and FuBarFrame2:GetPoint()=="BOTTOMLEFT" and FuBarFrame2:IsVisible() then
			height = height + (FuBarFrame2:GetHeight())
		end
		if TitanPanelAuxBarButton and TitanPanelAuxBarButton:GetPoint()=="BOTTOMLEFT" and TitanPanelAuxBarButton:IsVisible() then
			height = height + (TitanPanelAuxBarButton:GetHeight())
		end
		if yOfs~=height then
			SpartanUI:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 0, height)
			SpartanUI:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", 0, height)
		end
	end
end

function Sui_OnUpdate(self, elapsed)
	TimeSinceLastUpdate_GeneralInterval = TimeSinceLastUpdate_GeneralInterval + elapsed
	TimeSinceLastUpdate_AnimationInterval = TimeSinceLastUpdate_AnimationInterval + elapsed 
	TimeSinceLastUpdate_FastInterval = TimeSinceLastUpdate_FastInterval + elapsed
	if (TimeSinceLastUpdate_GeneralInterval > SUI_VarUpdateInterval) then				-- 1FPS
		TimeSinceLastUpdate_GeneralInterval = 0
		
		if IsAddOnLoaded("FuBar")==1 or IsAddOnLoaded("Titan")==1 then
			if FuBarFrame1 then
				Sui_PanelOffset(FuBarFrame1)
			end
			if TitanPanelBarButton then
				Sui_PanelOffset(TitanPanelBarButton)
			end
			if not FuBarFrame1 and not TitanPanelBarButton then
				Sui_PanelOffset("reset")
			end
			if FuBarFrame1 and FuBarFrame1:GetPoint()~="BOTTOMLEFT" and FuBarFrame1:IsVisible() then
				Sui_PanelOffset("reset")
			end
		end
		
		
    	--|  Minimap Coords  |--
    	local posX, posY = GetPlayerMapPosition("player")
   		posX = (math.floor(posX * 1000)) * .1
		posY = (math.floor(posY * 1000)) * .1
		if posX==0 and posY==0 then
			local inInstance, instanceType = IsInInstance()
			if not inInstance and not WorldMapFrame:IsVisible() then
				SetMapToCurrentZone()
			end
		end
		SUI_MinimapCoords:SetText(posX.." | "..posY)
		
		
		--| Readycheck |--
		SUI_ReadyCheckTimer = SUI_ReadyCheckTimer + 1
		if ( SUI_ReadyCheckTimer == 30 ) then
			SUI_Self_ReadyYes:Hide()
			SUI_Self_ReadyNo:Hide()
		end
		
		if not SUI_FirstLoad then
			if FrameAdvance>1 then
				Sui_BarFix()
				Sui_ChatFrame("setup")
				SUI_FirstLoad=0
				if IsAddOnLoaded("Adapt")==1 then
					
					-- SUI_Target_PortraitModelModel:SetParent(SUI_Target)
	    			-- SUI_Target_PortraitModelModel:SetFrameLevel(1)
	    		
    			end
			end
		end
		
		if MouseIsOver(ChatFrame1)==1 or MouseIsOver(ChatFrame2)==1 or MouseIsOver(ChatFrame3)==1 or MouseIsOver(ChatFrame4)==1 or MouseIsOver(ChatFrame5)==1 or MouseIsOver(ChatFrame6)==1 or MouseIsOver(ChatFrame7)==1 then
			Sui_ChatFrame("show")
		else
			Sui_ChatFrame("hide")
		end
		
  	end
  	
	if (TimeSinceLastUpdate_AnimationInterval > (SUI_VarUpdateInterval*0.08)) then		-- 12.5 FPS
		TimeSinceLastUpdate_AnimationInterval = 0
		FrameAdvance = FrameAdvance + 1
		
		Sui_Animation("player", "Health", "SUI_Self", 148, 16, "left", 3)
		Sui_Animation("player", "Power", "SUI_Self", 155, 15, "left", 3)
		
		if SUI_Pet:IsVisible() then
			Sui_Animation("pet", "Health", "SUI_Pet", 130, 13, "left", 3)
			Sui_Animation("pet", "Power", "SUI_Pet", 130, 13, "left", 3)
		end
		if SUI_Focus:IsVisible() then
			Sui_Animation("focus", "Health", "SUI_Focus", 130, 13, "right", 3)
			-- Sui_Animation("focus", "Power", "SUI_Focus", 130, 13, "right", 3)
		end
		if SUI_TargetFrame:IsVisible() then
			Sui_Animation("target", "Health", "SUI_Target", 148, 16, "right", 3)
			Sui_Animation("target", "Power", "SUI_Target", 155, 15, "right", 3)
			if UnitExists("targettarget") then
				if not suiData.currentTOT or suiData.currentTOT~=UnitGUID("targettarget") then
					suiData.currentTOT = UnitGUID("targettarget")
					Sui_SetupMembers("targettarget", "setup")
				end
			else
				suiData.currentTOT = "none"
				if SUI_TOT:IsVisible() then
					Sui_SetupMembers("targettarget", "setup")
				end
			end
		end
		if SUI_Party1:IsVisible() then
			--message("party1 is visible")
			Sui_Animation("party1", "Health", "SUI_Party1", 120, 15, "left", 3)
			Sui_Animation("party1", "Power", "SUI_Party1", 136, 14, "left", 3)
		end
		if SUI_Party2:IsVisible() then
			Sui_Animation("party2", "Health", "SUI_Party2", 120, 15, "left", 3)
			Sui_Animation("party2", "Power", "SUI_Party2", 136, 14, "left", 3)
		end
		if SUI_Party3:IsVisible() then
			Sui_Animation("party3", "Health", "SUI_Party3", 120, 15, "left", 3)
			Sui_Animation("party3", "Power", "SUI_Party3", 136, 14, "left", 3)
		end
		if SUI_Party4:IsVisible() then
			Sui_Animation("party4", "Health", "SUI_Party4", 120, 15, "left", 3)
			Sui_Animation("party4", "Power", "SUI_Party4", 136, 14, "left", 3)
		end
		if SUI_TOT:IsVisible() then
			Sui_Animation("targettarget", "Health", "SUI_TOT", 120, 15, "right", 3)
			Sui_Animation("targettarget", "Power", "SUI_TOT", 136, 14, "right", 3)
		end
		-- if SUI_TOTT:IsVisible() then
		--	Sui_Animation("targettargettarget", "Health", "SUI_TOTT", 148, 16, "right", 3)
		--	Sui_Animation("targettargettarget", "Power", "SUI_TOTT", 155, 15, "right", 3)
		-- end

		
		if (FrameAdvance < 5) then
			SUI_XP_Increase:Show()
			Sui_XPIncrease()
		elseif (FrameAdvance > 5) then
			SUI_XP_Increase:Hide()
		end
		
		if MouseIsOver(SUI_PopLeft_Hit, 0, 0, 0, 0)==1 then
			SUI_BarPoppupLeft_Top:Hide()
		elseif MouseIsOver(SUI_PopRight_Hit, 0, 0, 0, 0)==1 then
			SUI_BarPoppupRight_Top:Hide()
		else
			SUI_BarPoppupLeft_Top:Show()
			SUI_BarPoppupRight_Top:Show()
		end
		
	end	
	
	--|  CastBar animation  |--
	if (TimeSinceLastUpdate_FastInterval > (SUI_VarUpdateInterval/32)) then				-- 32 FPS
		if SUI_MouseTooltip:IsVisible() then
			local x, y = GetCursorPosition()
			local realScale = (UIParent:GetEffectiveScale())*(suiData.scale)
			SUI_MouseTooltip:SetPoint("BOTTOMLEFT", "UIParent", "BOTTOMLEFT", x/realScale-6, y/realScale+20)
		end
	
		if player_isCasting==1 or player_isChanneling==1 then
			Sui_CastAnimate("player")
			Sui_Animation("player", "Cast", SUI_Self_CastBar, 146, 16, "left", 1)
		end
		if focus_isCasting==1 or focus_isChanneling==1 then
			Sui_CastAnimate("focus")
			Sui_Animation("focus", "Cast", SUI_Focus_CastBar, 130, 13, "right", 1)
		end
		if target_isCasting==1 or target_isChanneling==1 then
			Sui_CastAnimate("target")
			Sui_Animation("target", "Cast", SUI_Target_CastBar, 146, 16, "right", 1)
		end
		if party1_isCasting==1 or party1_isChanneling==1 then
			Sui_CastAnimate("party1")
			Sui_Animation("party1", "Cast", SUI_Party1_CastBar, 120, 15, "left", 1)
		end
		if party2_isCasting==1 or party2_isChanneling==1 then
			Sui_CastAnimate("party2")
			Sui_Animation("party2", "Cast", SUI_Party2_CastBar, 120, 15, "left", 1)
		end
		if party3_isCasting==1 or party3_isChanneling==1 then
			Sui_CastAnimate("party3")
			Sui_Animation("party3", "Cast", SUI_Party3_CastBar, 120, 15, "left", 1)
		end
		if party4_isCasting==1 or party4_isChanneling==1 then
			Sui_CastAnimate("party4")
			Sui_Animation("party4", "Cast", SUI_Party4_CastBar, 120, 15, "left", 1)
		end
		if targettarget_isCasting==1 or targettarget_isChanneling==1 then
			Sui_CastAnimate("targettarget")
			Sui_Animation("targettarget", "Cast", SUI_TOT_CastBar, 146, 16, "right", 1)
		end
		-- if targettargettarget_isCasting==1 or targettargettarget_isChanneling==1 then
		-- 	Sui_CastAnimate("targettargettarget")
		-- 	Sui_Animation("targettargettarget", "Cast", SUI_TOTT_CastBar, 146, 16, "right", 1)
		-- end
		TimeSinceLastUpdate_FastInterval = 0
	end
end

function Sui_Finalize()
	SpartanUI:SetScale(0.78)	
end